      function bonderr(x,y,z,symm,natom,itype)
      include 'Gpops.h'
      include 'Atoms.h'
      dimension zocc(natf)
      common /fomgen2/ntypes,zocc
C     Generate a bonding constraint term
      logical dist3Dr
      character*4 symm
      dimension x(*),y(*),z(*),xe(12),ye(12), itype(*)
C      dimension bumpa(10,10),bonda(10,10),itype(*)
C      common /cmod01/bumpa,bonda
C      common /cbnd01/bonding
C      common /cbnd02/bondcon
       include 'newbonds.h'
        bonderr=0
        if(.not.bonding)return
        berr=0
        do j1=1,natom
                call asymm(x(j1),y(j1),ne,xe,ye,symm)
                k1=itype(j1)
                dmin=5
                do j2=1,natom
C                       dz=z(j1)-z(j2)
                        dz=0
                        k2=itype(j2)
                        tol=bonda(k1,k2)
C                       Trap tol < 0.25 indicating no bonding
                        if(tol.lt.0.25)goto 20
                        n0=1
                        if(j1.eq.j2)n0=2
                        do n=n0,ne
                                dx=x(j2)-xe(n)
                                dy=y(j2)-ye(n)
                                dx=dx-nint(dx)
                                dy=dy-nint(dy)
                                if(dist3Dr(dx,dy,dz,tol,r))goto 10
C                               Find the closest deviation
                                dlow=sqrt(r)-tol
                                if(dlow.lt.dmin)dmin=dlow
                        enddo
20                      continue
                enddo
C               Add a constraint term if we get here
C               This occurs if the atom is not bonded
                berr=berr+dmin*dmin     
10              continue
        enddo
        bonderr=berr
        return
        end
