C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ORIGIN (H, K, FHK, I1, I2, SYMM, NREF )
C     defines origin for 2D unit cell
C     from convergence data
         INTEGER H(*), K(*)
         DIMENSION FHK(*)
         CHARACTER*4 SYMM
         LOGICAL CENTRO
         common /ccentr/centro
 
         I1 = (-1)
         I2 = (-1)
C     check if it has an inversion center
         CALL CNTRD (SYMM)
         IF (CENTRO) THEN
           CALL ORIGC (H,K,FHK,I1,I2,SYMM,NREF)
           RETURN
         ELSE IF (SYMM .EQ. 'p1  ') THEN
C     primitive
           CALL ORIGP (H,K,FHK,I1,I2,SYMM,NREF)
           RETURN
         ELSE IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
C     For the moment, skip p3 cases
           RETURN
         ELSE IF (SYMM .EQ. 'p11g' .OR. SYMM .EQ. 'c11m' .OR. SYMM .EQ.
     X      'p11m') THEN
           CALL ORIGL (K,H,FHK,I1,I2,SYMM,NREF)
         ELSE
           CALL ORIGL (H,K,FHK,I1,I2,SYMM,NREF)
         END IF
         RETURN
       END
 
