C       Mean value, sum should be 1
        XMEAN = 1. / DBLE (N1 * N2)
C
C       New constant G constraint
C       Mean = (Number Atoms * Atom Height)/Area
C       Atom Height is essentially constant, independent of size
C       GGMAX is largest G*G, scales as the Area
C       Hence, Multiply by GGMAX to make heights size invariant
C       Reference to 1.1 Angstroms resolution (?)
C       IF(LGCON)XMEAN=XMEAN*GGMAX*(1.1*1.1)
C
C       Try fs2002 term
        TSTOE=1
        ENTMUL=1
        ENTSCL=1
C       If cellc is true, we have two atoms per cell in identical positions
C       This does not alter the mean normalization, but does the total for MaxEnt
C       if(cellc)ENTMUL=2
        BCUT=BCUTP*XMEAN
C
        if((LENT2).and.(STOE .gt.1.))then
                IF(LENT3)then
                        TSTOE=STOE
                        XMEAN=XMEAN/TSTOE
                        ENTMUL=TSTOE
                        ENTSCL=1./(1+LOG(STOE))
                ELSE
                        TSTOE=STOE*STOE
                        XMEAN =XMEAN/TSTOE
                        ENTMUL=ENTMUL*TSTOE
                ENDIF
        else
                ENTSCL=1.D0/(1.+2.*LOG(STOE))
        endif
        FTEMP=XMEAN
C       write(10,*)LENT2,LENT1,STOE,TSTOE,XMEAN,ENTMUL

