C	**** Start of New Code ***
C     	calculate the structure factors
        indfix=1
        PI   = acos(-1.)
        PIBT = asin(1.)
      	call gen3D(F2,IH,K,L,NPAD,f0,xray)
      	V00 = ABS (F2(I0))
        ZSL = 0
C        write(10,*)I0,V00,F2(I0)
C      	do i=1,npad
C            F2(i)=F2(i)/V00
C      	enddo
           SRMS = 0.
           NFULL = 0
	   SRMSU = 0.
           SRMSW = 0.
           IF (PMASK) THEN
             DO   I=1,NREF
               IHH = IH(I)
               IKK = K(I)
               CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
               IF (IHH .LT. 0 .OR. IKK .LT. 0) THEN
                 DO   N=1,NE
                   IF (HE(N) .GT. DD1 .AND. KE(N) .GT. DD2) THEN
                     IHH = HE(N)
                     IKK = KE(N)
                   END IF
                 END DO
               END IF
               FF = ABS (F2(i))
C     Scaling for <E^2> normalization
               IF (IHH .NE. 0 .OR. IKK .NE. 0) THEN
                 SCONT = FHK(I) * V00 / FF
                 SRMS = SRMS + SCONT * SCONT !*NE
                 NFULL = NFULL + 1 !NE
               END IF
               TEMP = WTS(I) * V00 / FF
C           ww=wts(i)
               WTS(I) = DBLE (FF) / (WTS(I) * V00)
               FHK(I) = FHK(I) * TEMP
	       SRMSU  = SRMSU + FHK(I)*FHK(I) !*NE
C              WW is the window
               WW = TEMP * FF / (V00*WTS(I))
               TEMP = FHK(I)/WW
               SRMSW = SRMSW + TEMP*TEMP !*NE
             END DO
           ELSE
             DO 2 I=1,NREF
               IHH = IH(I)
               IKK = K(I)
               CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
               IF (IHH .LT. 0 .OR. IKK .LT. 0) THEN
                 DO   N=1,NE
                   IF (HE(N) .GT. DD1 .AND. KE(N) .GT. DD2) THEN
                     IHH = HE(N)
                     IKK = KE(N)
                   END IF
                 END DO
               END IF
               FF = ABS (F2(I))
               IF (IHH .NE. 0 .OR. IKK .NE. 0) THEN
                 SCONT = FHK(I) * V00 / FF
                 SRMS = SRMS + SCONT * SCONT  !* NE
                 NFULL = NFULL + 1 !NE
               END IF
               SRMSU = SRMSU + FHK(I)*FHK(I) !*NE
               SRMSW = SRMSU
               TEMP = V00 / FF
               WTS(I) = 1.D0 / TEMP
               FHK(I) = FHK(I) * TEMP
    2          CONTINUE
           END IF
           IF (PMASK) THEN
 
C     Normalization terms for padded beams
             DO   I=NREF+1,NPAD
               IHH = IH(I)
               IKK = K(I)
               L(I) = 0
               CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
               IF (IHH .LT. 0 .OR. IKK .LT. 0) THEN
                 DO   N=1,NE
                   IF (HE(N) .GT. DD3 .AND. KE(N) .GT. DD4) THEN
                     IHH = HE(N)
                     IKK = KE(N)
                   END IF
                 END DO
               END IF
               FF = ABS (F2(I))
               TEMP = WTS(I) * V00 / FF
               WTS(I) = DBLE (FF) / (WTS(I) * V00)
               FHK(I) = 0
             END DO
           ELSE
             DO 3 I=NREF+1,NPAD
               IHH = IH(I)
               IKK = K(I)
		   FHK(I) = 0
               CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
               IF (IHH .LT. 0 .OR. IKK .LT. 0) THEN
                 DO   N=1,NE
                   IF (HE(N) .GT. DD3 .AND. KE(N) .GT. DD4) THEN
                     IHH = HE(N)
                     IKK = KE(N)
                   END IF
                 END DO
               END IF
               FF = ABS (F2(I))
               TEMP = V00 / FF
               WTS(I) = 1.D0 / TEMP
               FHK(I) = FHK(I) * TEMP
    3          CONTINUE
           END IF
 
C     Dividing by sqrt(srms/nfull) will normalize <E^2> to 1
C           STOE = SQRT (asin(1.0)*NFULL / SRMS)
            STOE = SQRT ( NFULL/SRMS )
C     If unorm is set, fudge by setting F0 negative
      WASF0=F0
      if(unorm)F0=-1.0
C     Same for fixing a particular HKL
      if(lshkl)then
           INDFIX=-1
C          Find relevant beam
             DO J=1,NREF
                CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
                DO N=1,NE
                   if((HE(N) .eq. HFIX).and.(KE(N) .eq. KFIX))then
                        INDFIX=J
                        GOTO 7100
                   endif
                ENDDO
            ENDDO
C           Trap not finding the beam
7100        if(INDFIX .gt. 0)F0=-1.0
       endif
C     F0 the effective number of atoms - divide by root of this if > 0
           IF (F0 .GT. 1.D0) THEN
             RSCALE = STOE / SQRT (F0)
             WRITE (10, *)
             WRITE (10, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             WRITE (10, *) 'Using Neff=sum[F(0,0)]^2/{sum[F(0,0)^2]}'
             WRITE (10, *) 'Rescaling: Effective number of input atoms '
     X          , F0
             WRITE (10, *) 'Scaling from <E^2>=1', STOE
             WRITE (10, *) 'Nett rescaling ', RSCALE, ' (=', STOE,
     X          '/sqrt(N))'
             WRITE (6, *)
             WRITE (6, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             WRITE (6, *) 'Using Neff=sum[F(0,0)]^2/{sum[F(H,K)^2]}'
             WRITE (6, *) 'Rescaling: Effective number of input atoms '
     X          , F0
             WRITE (6, *) 'Scaling from <E^2>=1', STOE
             WRITE (6, *) 'Nett rescaling ', RSCALE, ' (=', STOE,
     X          '/sqrt(N))'
             DO   I=1,NREF
               FHK(I) = FHK(I) * RSCALE
             END DO
             FHK(I0) = 1.
             STOE = sqrt(F0) 
           ELSE IF (XRAY) THEN
C     Adjust up the fhk's by sqrt(pi) - seems to be about right (why ?)
             SCLEUP = PI
             DO   J=1,NREF
                IF((IH(J).NE.0).or.(K(J).NE.0))THEN
                        FHK(J) =  FHK(J)* SCLEUP
                ENDIF
             END DO
             FHK(I0) = 1.
             WRITE (10, *)
             WRITE (10, *) 'Scaling from <E^2>=1', STOE
             WRITE (10, *) 'No Rescaling, Sum{F^2}=pi used'
             WRITE (6, *)
             WRITE (6, *) 'Scaling from <E^2>=1', STOE
             WRITE (6, *) 'No Rescaling, Sum{F^2}=pi used'
             STOE = STOE/sqrt(2*pi)
           ELSE IF (LSHKL)  THEN
             WRITE (10, *)
             WRITE (10, *) 'Scaling from <E^2>=1', STOE
             WRITE (10, *) 'Fixed scaling used'
             WRITE (10, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             WRITE (6, *)
             WRITE (6, *) 'Scaling from <E^2>=1', STOE
             WRITE (6, *) 'Fixed scaling used'
             WRITE (6, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             F0 = 1.
C       Note, to remove window use
            FF = ABS (F2(INDFIX))
            TEMP = 1.D0 / WTS(INDFIX)
            WW = TEMP * FF / V00
C            WW is the window
             SRMSU = UFIX*WW/FHK(INDFIX)
             DO J=1,NREF
                IF((IH(J).NE.0).or.(K(J).NE.0))then
                        FHK(J) = FHK(J)*SRMSU
                ENDIF
             ENDDO
             STOE=STOE/sqrt(pibt)
           ELSE IF (unormu) THEN
             WRITE (10, *)
             WRITE (10, *) 'Scaling from <E^2>=1', STOE
             WRITE (10, *) 'No Rescaling, Sum{U*Window}^2=1 used'
             WRITE (10, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             WRITE (6, *)
             WRITE (6, *) 'Scaling from <E^2>=1', STOE
             WRITE (6, *) 'No Rescaling, Sum{U*Window}^2=1 used'
             WRITE (6, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             F0 = 1.
	     SRMSU = sqrt(SRMSU)
	     DO J=1,NREF
		IF((IH(J).NE.0).or.(K(J).NE.0))THEN
                        FHK(J) = FHK(J)/SRMSU
                ENDIF
	     ENDDO
             STOE=STOE/sqrt(pibt)
           ELSE IF (unorm3) THEN
             WRITE (10, *)
             WRITE (10, *) 'Scaling from <E^2>=1', STOE
             WRITE (10, *) 'No Rescaling, Sum{U^2}=1 used'
             WRITE (10, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             WRITE (6, *)
             WRITE (6, *) 'Scaling from <E^2>=1', STOE
             WRITE (6, *) 'No Rescaling, Sum{U^2}=1 used'
             WRITE (6, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             F0 = 1.
             SRMSW = sqrt(SRMSW)
             DO J=1,NREF
                IF((IH(J).NE.0).or.(K(J).NE.0))FHK(J) = FHK(J)/SRMSW
              ENDDO
              STOE=STOE/sqrt(pibt)
 	  ELSE
             WRITE (10, *)
             WRITE (10, *) 'Scaling from <E^2>=1', STOE
             WRITE (10, *) 'No Rescaling, Sum{F^2}=1 used'
             WRITE (10, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
             WRITE (6, *)
             WRITE (6, *) 'Scaling from <E^2>=1', STOE
             WRITE (6, *) 'No Rescaling, Sum{F^2}=1 used'
             WRITE (6, *) 'Using Feff(H,K)=sqrt{sum[F(H,K)^2]}'
            F0 = 1
            STOE=STOE/sqrt(pibt)
            END IF
        MULTI(I0) = 1
        MultZero  = 1
C       Store F0 for possible later use
        FNATM = max (1., stoe*stoe)
       write(10,*)'Effective number of atoms ',fnatm 
           IF (WT2ON) THEN
             IF (PMASK) THEN
               IF (PRINTF) WRITE (10, 1481)
               IF (PRINTF) WRITE (6, 1481)
 1481          FORMAT(/'Rescaled Data:'/,
     X       '    H    K    L     U(H,K)     Angle',
     X       '     Scaling    Window     1/S.F.     Weight')
 
             ELSE
 
               IF (PRINTF) WRITE (10, 1483)
               IF (PRINTF) WRITE (6, 1483)
 1483          FORMAT(/'Rescaled Data:'/,
     X            '    H    K    L     U(H,K)     Angle',
     X            '      1/S.F.    Weight')
             END IF
           ELSE
             IF (PMASK) THEN
               IF (PRINTF) WRITE (10, 481)
               IF (PRINTF) WRITE (6, 481)
  481          FORMAT(/'Rescaled Data:'/,
     X            '    H    K    L     U(H,K)     Angle',
     X            '     Scaling    Window     1/S.F.') 
             ELSE
 
               IF (PRINTF) WRITE (10, 483)
               IF (PRINTF) WRITE (6, 483)
  483          FORMAT(/'Rescaled Data:'/,
     X            '    H    K    L    U(H,K)    Angle','    1/S.F.')
             END IF
           END IF
           IF (PMASK) THEN
 
             DO   I=1,NPAD
               IHH = IH(I)
               IKK = K(I)
               IF (IH(I) .LT. 0 .OR. K(I) .LT. 0) THEN
                 CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
                 DO   N=1,NE
                   IF (HE(N) .GT. DD5 .AND. KE(N) .GT. DD6) THEN
                     IHH = HE(N)
                     IKK = KE(N)
                   END IF
                 END DO
               END IF
               FF = ABS (F2(I))
               TEMP = 1.D0 / WTS(I)
               WW = TEMP * FF / V00
               IF (WT2ON) THEN
C       EWTS is <S>/<N> Level
C       RSN as an estimate of <N>/<S> ratio
                RSN = EWTS(I)/(EWTS(I)*EWTS(I)+1D-10)
C       TEMP is the scaling used to increase from raw value
C       FT is a Wiener-type filter
                FT = 1.d0/(1.d0+RSN*TEMP*TEMP)
C                TEMPI=1./TEMP
C                FT = TEMPI*TEMPI/(TEMPI*TEMPI+RSN)
C                FT = 1.D0/(1.D0+RSN) -- old version
                FHK(I) = FHK(I)*FT
                WTS(I) = WTS(I)/FT
                TEMP = TEMP * FT
                ENDIF
                IF(WT2ON .AND. PRINTF) THEN
                 WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I), TEMP
     X              , WW, V00 / FF, FT
                 WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I), TEMP,
     X              WW, V00 / FF, FT
               ELSE IF (PRINTF) THEN
                 WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I), TEMP
     X              , WW, V00 / FF, ENTW(I)/ENTW(I0)
                 WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I), TEMP,
     X              WW, V00 / FF, ENTW(I)/ENTW(I0)
               END IF
             END DO
           ELSE
             DO 4 I=1,NPAD
               IHH = IH(I)
               IKK = K(I)
               IF (IH(I) .LT. 0 .OR. K(I) .LT. 0) THEN
                 CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
                 DO   N=1,NE
                   IF (HE(N) .GT. DD5 .AND. KE(N) .GT. DD6) THEN
                     IHH = HE(N)
                     IKK = KE(N)
                   END IF
                 END DO
               END IF
               FF = ABS (F2(I))
               IF (WT2ON .AND. PRINTF) THEN
                 WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I), V00 /
     X               FF, EWTS(I)
                 WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I), V00 /
     X              FF, EWTS(I)
               ELSE IF (PRINTF) THEN
                 WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I), V00 /
     X               FF
                 WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I), V00 /
     X              FF
               END IF
    4          CONTINUE
           END IF
 
         END IF
C	**** End of New Code
C
C       Add stuff for calculating model here
        if(modelmode)then
C               setupmodel
        endif

