C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION TB2D (IH, K, FHK, AHK, AIN, NREF, NCON, CFLAG, SYMM,
     X    NBEAMS, NHK, C, M, IOPT)
C
C
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         dimension fmodel(NHK2),amodel(nhk2)
         INCLUDE 'NewStuff.h'
         INCLUDE 'TModel.h'
         LOGICAL PRINTF, SCALEFIRST,ITERMODE
         parameter (SCALEFIRST=.false.)
         parameter (ITERMODE=.false.)
         COMMON /PRINTS/PRINTF
         LOGICAL PWMASK, EOPT, PWACC, PMACC, Centref(nhk2)
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         DIMENSION IH(NHK2), K(NHK2), FHK(NHK2), AHK(NHK2), AOLD(NHK2), 
     X   AIN(NHK2)
         DIMENSION FRCALC(NHK2), FICALC(NHK2), ARCALC(NHK2)
         DIMENSION FCALC(NHK2), ACALC(NHK2), AICALC(NHK2)
         DIMENSION WR(NHK2), WI(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*)
         COMPLEX*16 W1, W2, RES1, RES2
         real*8 res1A(2), res2A(2)
         equivalence (res1,res1A), (res2,res2A)
         DOUBLEPRECISION R1, R2, BRSUM, BISUM, PI, PI2
         DOUBLEPRECISION SR, SI, FC, ACONV, XR1, XR, ANG, FSQ
         DOUBLEPRECISION COSAN, SINAN, F, AISUM, ARSUM
         LOGICAL CFLAG
         CHARACTER*4 SYMM
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         DOUBLEPRECISION Third, OFFSET
         PARAMETER (Third = 1.D0 / 3.D0, OFFSET=1.0D0)
         LOGICAL P3FLAG
         COMPLEX*16 ComplexHalf
         PARAMETER (ComplexHalf = (0.D0,-0.5D0))
C        Window Rescaling
         Include 'WNorm.h'
C        Parameters for when angle ~0 and slow development (fs2002)
         parameter (ACUT=1D-4 , WUNSET=0.D0)
         complex fentry(nhk2),predf(nhk2),fold(nhk2)
         save fmodel,amodel,fold

         CALL CNTRD (SYMM)
         P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
 
C     Angle conversion scaler
         PI = ACOS (-1.D0)
         PI2 = PI * 2.D0
         ACONV = 180.D0 / PI
 
         IF (PRINTF) WRITE (10, 998) NCON
 
  998    FORMAT('***** START OF ITERATION NUMBER ',I3,2X,'*****'/2X,'H',
     X      2X,'K',4X,'A1',6X,'F1',6X,'A2',6X,'F2',5X,'AOLD',4X,'FOLD',4
     X      X,'ANEW',5X,'FNEW',4X,'Diff')
 
C     Zero estimates for first cycle
         IF (NCON .EQ. 1) THEN
           DO   J=NREF+1,NPAD
             FHK(J) = 0.
             AHK(J) = 0.
             FCALC(J) = 0.
           END DO
         ENDIF
C     save input values
         DO   J=1,NPAD
           AOLD(J) = AHK(J) * ACONV
           ACALC(J) = 0.
           call equiv2(he,ke,ise,ih(j),k(j),ne,symm)
           centref(j)=.false.
           if(ise(1).eq.3)centref(j)=.true.
         END DO
         FMAX=FHK(1)
         DO J=2,NREF-1
             IF ((FHK(J) .GT. FMAX)) FMAX = FHK(J)
         ENDDO
C     setup in c the symmetry related values
         DO   J=1,N1*N2
           C(J) = 0.D0
         END DO

         IF(modelmode)then
C        ********* Angle definitions for model *********
         if(.not.gotmodel)then
           call SetupModel(ih,k,l,fmodel,amodel,wts,nref,npad,symm)
           call TMODMASK (IH, K, Fmodel, Amodel, SYMM, C, M )
           gotmodel=.true.
         endif
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
           IF (centref(j) .AND. ABS (AHK(J)) .GT. 1D-4) THEN
              ia=nint(ang/pi)
              if(2*(ia/2).eq.ia)then
                ia=2
              else
                ia=1
              endif
              ang=ia*pi
             AHK(J) = ang
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.
             SINAN = 0.
             F = 1.
           ELSE IF (ABS (ANG) .LT. 1D-4) THEN
             F = 0.
             COSAN = 0.
             SINAN = 0.
           ELSE
             COSAN = COS (ANG) * FHK(J)
             SINAN = SIN (ANG) * FHK(J)
           END IF
C     Information about symmetry coding of phases
           COSM = FMODEL(J)*COS(AMODEL(J))
           SINM = FMODEL(J)*SIN(AMODEL(J))
           if(centref(j))then
                SINM=0
                SINAN=0
           endif           
           fentry(j)=cmplx(cosan,sinan)
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (P3FLAG) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IND = (IKJJ - 1) * N1 + IHJJ
C            Other is CMPLX( -SINM, COSM)
             IF (ISE(JJ) .LT. 0) THEN
               C(IND) = CMPLX (COSAN+SINM, -SINAN+COSM)
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               C(IND) = CMPLX (COSAN, COSM)
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               C(IND) = CMPLX (-SINM, SINAN)
             ELSE IF (ISE(JJ) .LT. 8) THEN
               C(IND) = CMPLX (COSAN-SINM, SINAN+COSM)
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = ANG + HE(1) * PI
               C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
               AWORK = AMODEL(J) + HE(1) * PI
               C(IND) = C(IND) + FMODEL(J)*CMPLX(-SIN(AWORK),COS(AWORK))
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               C(IND) = -CMPLX (COSAN-SINM, SINAN+COSM)
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               C(IND) = -CMPLX (COSAN+SINM, -SINAN+COSM)
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               C(IND) = -CMPLX (COSAN, COSM)
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               C(IND) = CMPLX (SINM, -SINAN)
             END IF
           END DO
         END DO
C        ********* Normal Case ********
         else
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
C       Trap ?
           call anglefix(ang,p3flag)
           AHK(J) = ANG
           IF (centref(j) .AND. ABS (ANG) .GT. 1D-4) THEN
              ia=nint(ang/pi)
              if(2*(ia/2).eq.ia)then
                ia=2
              else
                ia=1
              endif
              ang=ia*pi
              AHK(J) = ang
              AOLD(J) = AHK(J) * ACONV
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.D0
             SINAN = 0.D0
             F = 1.D0
             FHK(J) = 1.
             AHK(J) = PI2
             AOLD(J) = 360.
           ELSE IF (ABS (ANG) .LT. ACUT) THEN
             F = 0.D0
             COSAN = 0.D0
             SINAN = 0.D0
             AOLD(J)= 0.D0
           ELSE
             COSAN = COS (ANG) * F
             SINAN = SIN (ANG) * F
           END IF
      if(centref(j))sinan=0
      fentry(j)=cmplx(cosan,sinan)
      do jj=1,ne
C     trap problems with p3 symmetry to give rectangular axes
         if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')then
            call p3exp(ihjj,ikjj,he(jj),ke(jj))
            ihjj=ihjj+n1c
            ikjj=ikjj+n2c
          else
            ihjj=he(jj)+n1c
            ikjj=ke(jj)+n2c
         endif
         ind=(ikjj-1)*n1+ihjj
         isjj=ise(jj)
         if(isjj.lt.0)then
            C(ind)=cmplx(cosan,-sinan)
        else if(isjj.lt.2)then
            C(ind)=cmplx(cosan,sinan)
         else if(isjj.eq.3)then
            C(ind)=cmplx(cosan,0.d0)
         else if(isjj.eq.6)then
            C(ind)=cmplx(0.d0,sinan)
         else if(isjj.lt.8)then
            C(ind)=cmplx(cosan,sinan)
         else if(isjj.lt.110)then
            awork=ang+he(1)*pi
            C(ind)=f*cmplx(cos(awork),sin(awork))

C     X or Y-glide
         else if(isjj.lt.210)then
            C(ind)=-cmplx(cosan,sinan)
         else if(isjj.eq.300)then
            C(ind)=-cmplx(cosan,-sinan)
            
C     p2mg case
         else if(isjj.eq.1000)then
            C(ind)=-cmplx(cosan,0.d0)
         else if(isjj.eq.2000)then
            C(ind)=cmplx(0.d0,-sinan)
         endif

           END DO
         END DO
C        ********* End of two cases *********
         endif
 
C     Negativity constraints via ftune(4)
         X1 = 0.
         XLAM = FTUNE(4) * (1 - EXP (0.5D0 - NCON * 0.5D0))
         X2 = XLAM
C     Model case -- flakey
      if(modelmode)then
C        Setup, then use model
         if(ncon.eq.1)then
         CALL MODELSHARP0(N1,N2,M,C,modelog1)
         else if (.not.modelog2)then
         CALL MODELSHARP(N1,N2,M,C,modelog1)
         else
         CALL MODELSTRONG(N1,N2,M,C,modelog1)
         endif
      else
         CALL SHPT2D (N1,N2,M,C,IOPT,X1,X2)
      endif
 
C     Outer loop for target reflections
         DO 1031 I=1,NPAD
           FRCALC(I) = 0.
           FICALC(I) = 0.
           ARCALC(I) = 0.
           AICALC(I) = 0.
           WI(I) = WUNSET
           WR(I) = WUNSET
C       Average over equivalent reflections
         call equiv2(he,ke,ise,ih(i),k(i),ne,symm)
         w1=0.
         w2=0.
         nnn=0
         do jt=1,ne
         if(ise(jt).eq.1.or.ise(jt).eq.3)then
           ihjj=he(jt)
           ikjj=ke(jt)
C     trap problems with p3 symmetry to give rectangular axes
         if(P3FLAG)call p3exp(ihjj,ikjj,he(jt),ke(jt))
          ih1=ihjj+n1c
          ik1=ikjj+n2c
          ih2=-ihjj+n1c
          ik2=-ikjj+n2c
         ind1=(ik1-1)*n1+ih1
         ind2=(ik2-1)*n1+ih2
         w1=w1+c(ind1)
         w2=w2+c(ind2)
         nnn=nnn+1
         endif

         enddo
         w1=w1/dble(nnn)
         w2=w2/dble(nnn)
C
C     Extract two terms from real and imag parts
           RES1 = (W1 + CONJG (W2)) * 0.5D0
           RES2 = (W1 - CONJG (W2)) * ComplexHalf
           if(centref(i))then
                res1 = dble(res1)
                res2 = dble(res2)
           endif
C    Correct for the effects of windows
        if((LENTR).and.(.not.lent3))RES2=RES2*ENTW(I)
        IF(LENT2)RES1=RES1*WNORM
C
C       Work around flakey g77 imag intrinsic
           ARSUM = res1a(1)
           BRSUM = res1a(2)
           AISUM = RES2a(1)
           BISUM = res2a(2)
 
           FSQ = ARSUM * ARSUM + BRSUM * BRSUM
           IF (FSQ .GT. 1D-16) THEN
             FRCALC(I) = SQRT (FSQ)
             ANG = ATAN2 (BRSUM, ARSUM)
             call anglefix2 ( ang, p3flag )
             ARCALC(I) = ANG
           END IF
           FSQ = AISUM * AISUM + BISUM * BISUM
           IF (FSQ .GT. 1D-16) THEN
             FICALC(I) = SQRT (FSQ)
             ANG = ATAN2 (BISUM, AISUM)
             call anglefix2 ( ang, p3flag )
             AICALC(I) = ANG
           END IF
C       Save values for pre-scaling
           WR(I) = COS (ARCALC(I) - AHK(I))
           WI(I) = COS (AICALC(I) - AHK(I))
           IF (AOLD(I) .LT. ACUT) THEN
             WI(I) = WUNSET
             WR(I) = WUNSET
           END IF
 1031      CONTINUE

C
C     These values are important
C     If the predicted value is too large or too small, it is
C     probably incorrect.  If it is too large, reverse it; if
C       it is too small, ignore it.
C       Note: Over-relaxation will take care of inverted signs,
C       but not too large values.
         SDEV = 0.45D0
         IF (FSTEST(8) .GT. 0.D0) SDEV = 1.D0 / FSTEST(8)
         DEV = EXP (NCON * SDEV - SDEV)
         NDEV = 5
         IF (FSTEST(9) .GT. 1) NDEV = NINT (FSTEST(9))
         FLOW = FMAX * 0.05 / DEV

C     calculate error terms
         CALL ERRNT2 (FHK,FRCALC,WR,NREF,IH,K,SCLR,AOLD)
         ER1 = SFERR2
C     Positivity
         CALL ERRNT2 (FHK,FICALC,WI,NREF,IH,K,SCLI,AOLD)
         EI1 = SFERR2
         SCALER = ABS (SCLR)
         SCALEI = ABS (SCLI)
C     Entropy
        if((ScaleFirst).and.RSCL1)then
         DO J=1,NPAD
                FRCALC(J)=FRCALC(J)*SCALER
                FICALC(J)=FICALC(J)*SCALEI
         ENDDO
       ENDIF
C
C       Slow development from fs2002 -- not sure why located here
C       Trap the setting of new reflections with small values
        if(slow)then
           prl=exp(-(ncon-1)/abs(slw1))/slw2
             if(prl.gt.0.01)then
                do j=1,nref-1
                  if(aold(j).lt.1e-3)then
                     if(frcalc(j).lt.prl*fhk(j)) then
                        frcalc(j)=0
                        arcalc(j)=0
                        ficalc(j)=0
                        aicalc(j)=0
                        ahk(J) =0
                        aold(j)=0
                        fentry(j)=0
                        WR(j)=WUNSET
                        WI(J)=WUNSET
                        fold(j)=0
                     else if(ficalc(j).lt.prl*fhk(j)) then
                        ficalc(j)=frcalc(j)
                        aicalc(j)=arcalc(j)
                        wi(J)=wr(J)
                     endif
                  endif
                enddo
             endif
        endif
C     Entropy
        IF((.not.ScaleFirst).and.(RSCL1))then
         DO J=1,NPAD
                FRCALC(J)=FRCALC(J)*SCALER
                FICALC(J)=FICALC(J)*SCALEI
         ENDDO
         ENDIF

C     Different cases
         IF (FTUNE(2) .LT. 1) THEN
C     Equal weighting
           SR = 0.5D0 * (1.D0 + EXP (-(NCON - OFFSET) * Third))
           SI = 1.D0 - SR
         ELSE IF (FTUNE(2) .LT. 2) THEN
C     Scale with FOM
           SR = EI1 / (EI1 + ER1)
           SI = ER1 / (EI1 + ER1)
         ELSE IF (FTUNE(2) .LT. 4) THEN
C     Consistency checker
           SR = 1.D0
           SI = 0.D0
         ELSE IF (FTUNE(2) .LT. 5) THEN
C     Just positivity
           SR = 0.D0
           SI = 1.D0
         ELSE IF (FTUNE(2) .LT. 6) THEN
C     2/3 Entropy, 1/3 Positivity, varying
           SR = (2.D0 + EXP (-(NCON - OFFSET) * Third)) *Third
           SI = ABS (SR - 1.D0)
         ELSE IF (FTUNE(2) .LT. 7) THEN
C     2/3 Entropy, 1/3 Positivity, fixed
           SI = Third
           SR = 1.D0 - Third
         ELSE IF (FTUNE(2) .LT. 8) THEN
C     0.5 Entropy, 0.5 Positivity
           SI = 0.25D0 + 0.25D0 * (1.D0 - EXP (-(NCON - OFFSET)*Third))
           SR = 1.D0 - SI
         ELSE
C     Default 2/3 Entropy, 1/3 Positivity, varying
           SR = (2.D0 + EXP (-(NCON - OFFSET) * Third)) *Third
           SI = ABS (SR - 1.D0)
         END IF
 
         XR1 = ABS (FTUNE(1))
         XR3 = FTUNE(3)
C     Automatic case, maybe not trustworthy
         IF (FTUNE(3) .GT. 10.D0) XR3 = FTUNE(3) - 10.D0
         IF (XR3 .LT. -0.01D0) XR3 = 0.5D0
         IF (FTUNE(1) .GT. 99.D0) THEN
C
           XX = ABS (FTUNE(3)) * (1 - EXP (-(NCON - OFFSET) * Third))
           XX = 1 + XX
           AT = XX + SR * (1 - XX)
           BT = XX * (2 - SR)
           IF (AT .LT. 1D-2) THEN
             XR1 = 1.D0
           ELSE
             XR1 = BT / AT
           END IF
           IF (XR1 .GT. 1.95D0) XR1 = 1.95D0
         ELSE
           IF (XR1 .GT. 10.D0) THEN
             XR1 = XR1 + INT (XR1 * 0.1D0) * (-10)
             IF (XR1 .GT. 10.D0) XR1 = XR1 - 10
             IF (XR1 .LT. 0.D0) XR1 = 10.D0 + XR1
             T=(1.D0 - EXP (-(NCON - 1.D0) / XR1))
             XR1 = 1 + XR3 * T
             IF (XR1 .LT. 0) XR1 = 0.1D0
           END IF
         END IF
         XR = XR1 - 1.D0
         S1 = 0.
         S3 = 0.
         SANG3 = 0.
C        write(10,*)'Trap ',SR,SI
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J) 
C     Combine the two for new values
           R1 = FRCALC(J) * COS (ARCALC(J)) * SR + FICALC(J) * COS (
     X        AICALC(J)) * SI
           if(centref(j))then
           R2 = 0
           else
           R2 = FRCALC(J) * SIN (ARCALC(J)) * SR + FICALC(J) * SIN (
     X        AICALC(J)) * SI
           endif
           FC = R1 * R1 + R2 * R2
           IF (FC .GT. 1D-12) THEN
             FCALC(J) = SQRT (FC)
             ANG = ATAN2 (R2, R1)
             call anglefix2 (ang,p3flag)
             ACALC(J) = ANG 
             WR(J) = COS (ANG - AHK(J))
             predf(j)=cmplx(r1,r2)
           ELSE
             FC = 0
             FCALC(J) = 0.
             ACALC(J) = 0.
             WR(J) = WUNSET
             AOLD(J) = 0.
             FOLD(J) = 0.
             Fentry(j) = 0.
             predf(j)  = 0.
             ahk(j) = 0.
           END IF

           IF (AOLD(J) .LT. ACUT) THEN
             WR(J) = WUNSET
           END IF
        ENDDO
         CALL ERRNT2 (FHK,FCALC,WR,NREF,IH,K,SCLT,AOLD)
         EC1 = SFERR2
         SCALET = ABS (SCLT)
         SFERR2 = ER1
         SFERR1 = EI1
         xo2=0.5+0.5*exp(-(ncon-1.)/3.)
         xo1=1-xo2
C
        DO J=1,NPAD
                if(RSCL1)then
                 fcalc(j)=fcalc(j)*scalet
                 predf(j)=predf(j)*scalet
                endif
C                Over-relax
                if(itermode .and. ncon.gt.2)then
                 predf(j)=predf(j)*xr1-(fold(j)*xo1+xo2*fentry(j))*xr
                else
                 predf(j)=predf(j)*xr1-fentry(j)*xr
                endif
                arsum=predf(j)
                aisum=aimag(predf(j))
                if(centref(j))aisum=0
                fsq=arsum*arsum+aisum*aisum
                if(fsq.gt.1d-12)then
                        fcalc(j)=sqrt(fsq)
                        ang=atan2(aisum,arsum)
                        if(ang.lt.5e-2)ang=ang+pi2
                        if(centref(j))then
C               truncate angle to moduli pi provided that > a cutoff
                                ia=nint(ang/pi)
                                if(2*(ia/2).eq.ia)then
                                        ia=2
                                else
                                        ia=1
                                endif
                                ang=ia*pi
                        endif
                        wr(j)=cos(ang-ahk(j))
                        acalc(j)=ang
                        ahk(j)=ang
                else
                        fcalc(j)=0
                        acalc(j)=0
                        wr(j)=WUNSET
                        predf(j)=0
                        ahk(j)=0
                        aold(j)=0
                        fold(j)=0
                        fentry(j)=0
                endif
        enddo
C       Scale the over-relaxed value
        call errnt2(fhk,fcalc,wr,nref,ih,k,scalec,aold)
        scalec=abs(scalec)
        do j=1,npad
                if(RSCL1)then
                fcalc(j)=fcalc(j)*scalec
                predf(j)=predf(j)*scalec
                endif
C       If the beam was not previously set...
                if(aold(j) .lt. 1e-2)then
                        fentry(j)=predf(j)
                        fold(j)=predf(j)
                endif
        enddo
        sferr1=er1
        sferr2=ei1
        
        DO J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           FC = FCALC(J)
           AR = ARCALC(J) * ACONV
           AI = AICALC(J) * ACONV
           AC = AHK(J) * ACONV
C     Reduce difference to smallest value with multivaluedness
           DELTA = AC - AOLD(J)
           DELTA1 = ABS (360 + DELTA)
           DELTA2 = ABS (DELTA - 360)
           DELTA = ABS (DELTA)
           IF (DELTA .LT. DELTA1 .AND. DELTA .LT. DELTA2) THEN
             DEL = AC - AOLD(J)
           ELSE IF (DELTA1 .LT. DELTA2) THEN
             DEL = 360.D0 + AC - AOLD(J)
           ELSE
             DEL = AC - 360.D0 - AOLD(J)
           END IF
           IF (ABS (ABS (DEL) - 180.D0) .LT. 1D-3) DEL = 180.
C     Trap undefined to 360
           IF (ABS (AOLD(J)) .LT. ACUT .AND. ABS (AC - 360) .LT. 1D-3)
     X        DEL = 360.
 
C     some sums for monitoring
           S1 = S1 + FHK(J)
           S3 = S3 + FHK(J) * DEL * DEL
 
C     Take all values for drift
           SANG3 = SANG3 + DEL * DEL
 
           IF (PRINTF) THEN
           IF(J.eq.NREF+1)WRITE (10, 1035)
             WRITE (10, 4) IH(J), K(J), AR, FRCALC(J), AI, FICALC(J),
     X          AOLD(J), FHK(J), AC, FCALC(J), DEL
    4        FORMAT(2I3,4(F8.3,F8.4),F8.3,F9.4)
           END IF
C          Set unmeasured
           if(J .GT. NREF)FHK(J)=FC
         END DO
 1035      FORMAT('**** Estimated Reflections')
C     X        /2X,'H',2X,'K',5X,'Fnew',5
C     X        X,'Anew',5X,'Fest',5X,'Aest',5X,'Fold',5X,'Aold',5X,'DAng'
C     X        ,5X,'DFHK')

         IF (MAX0 (NREF, 0) .GT. 0) THEN
           TB2D = SQRT (SANG3 / MAX0 (NREF, 0))
         ELSE
           TB2D = 10.
         END IF
         IF (S3 .LT. 1D-5) THEN
           ANGERR = 0.
         ELSE
           ANGERR = SQRT (S3 / S1)
         END IF
 
         IF (PRINTF) THEN
           WRITE (10, 901) ' Phase Relaxation: ', XR1, ' Positivity ', 1
     X         + XLAM
           WRITE (10, 901) ' Scales of Entropy:', SCLR, ' Positivity:',
     X        SCLI,' Combination ',Scalet
           WRITE (10, 901) ' Weight of Entropy:', SR, ' Positivity:', SI
  901      FORMAT(A,F10.5,A,F10.5,A,F10.5)
         END IF
        if((ncon .lt. 2).or.(.not.rscl1))then
           do j=1,npad
                fold(j)=fentry(j)
           enddo
        else
           do j=1,npad
C       I wonder if one should use fold+predf here ?
C       No apparent effect
                fold(j)=(xo1*fold(j)+xo2*fentry(j))
C                fold(j) = xo1*predf(j)+xo2*fold(j)
           enddo
        endif
        SFERR2=ER1
        SFERR1=EI1
         RETURN
       END
C
        subroutine anglefix(ang,p3flag)
        logical p3flag,init
        real*8 ang,f120,f240,pi,pi2
C
        data init/.true./
        save init,f120,f240,pi,pi2
        if(init)then
                pi=acos(-1.0d0)
                pi2=2.d0*pi
                f120=pi*2.d0/3.d0
                f240=pi*4.d0/3.d0
                init=.false.
        endif
C        if(ang .lt. 1d-2)ang=ang+pi2
C        ijunk=-1
C        if(ijunk.lt.0)return
        IF(P3FLAG)then
C       Trap angles very close to 120,240
        if(abs(ang-f120).lt.1d-4)ang=f120
        if(abs(ang-f240).lt.1d-4)ang=f240
        endif
C       Fix 180,360
        if(abs(ang-pi).lt.1d-4)ang=pi
        if(abs(ang-pi2).lt.1d-4)ang=pi2
        return
        end
        subroutine anglefix2 (ang,p3flag)
        logical p3flag,init
        real*8 ang,f120,f240,pi,pi2
C
        data init/.true./
        save init,f120,f240,pi,pi2
        if(init)then
                pi=acos(-1.0d0)
                pi2=2.d0*pi
                f120=pi*2.d0/3.d0
                f240=pi*4.d0/3.d0
                init=.false.
        endif
        if(ang .lt. 1d-2)ang=ang+pi2
C        ijunk=-1
C        if(ijunk.lt.0)return
        IF(P3FLAG)then
C       Trap angles very close to 120,240
        if(abs(ang-f120).lt.1d-4)ang=f120
        if(abs(ang-f240).lt.1d-4)ang=f240
        endif
C       Fix 180,360
        if(abs(ang-pi).lt.1d-4)ang=pi
        if(abs(ang-pi2).lt.1d-4)ang=pi2
        return
        end

