C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE GETIN (SYMM, XRAY, TITLE, PMASK, PCOR, NITER, CVAR,
     X    PRINTF )
         PARAMETER (NMAX = 80, NHK2=900)
         include 'NewIncludes.h'
         include 'newbonds.h'
         LOGICAL FCHAR, FCHAR4, FGET98, FINT, XRAY
         LOGICAL PMASK, PRINTF
         CHARACTER*4 SYMM, CVAL
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
C         COMMON /NEWSTUFF/POWER, FLIP
         include 'NewStuff.h'
         CHARACTER*80 LINE, LINE2
         CHARACTER*80 TITLE
         CHARACTER*1 DUM
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         COMMON /DIVAMP/CAMP
         DIMENSION EWTS(NHK2)
         LOGICAL WT2ON, PATTON
         COMMON /MOPTS/ PATTON, PLUS1, PLUS2, PLUS3, PLUS4, PLUS5
         COMMON /WCOM2/EWTS, WT2ON
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/
         logical robnod,rob_fit,dwref,robfm,nodd5
         common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
         include 'ffact.h'
         include 'TModel.h'
         INCLUDE 'STO111.h'
C         logical gotrfacts,twin
C         common /rscom7/gotrfacts,twin
         nmust=0
         positivity = .false.
         FixPosScl = .false.
         RSCL1=.true.
         FIXF =.false.
         altp = .true.
         divne=.false.
         dsym=.false.
         slow=.false.
         slw1=3
         slw2=2
         atoms=1
         lent1=.false.
         lent2=.false.
         lent3=.false.
         lent4=.false.
         lent5=.false.
         lent6=.false.
         lent7=.false.
         czer=.false.
         czer2=.false.
         czer3=.false.
         ndforce=-1
         dwref=.false.
         twin=.false.
         cutmodel=0.5
         gotmodel=.false.
         modelmode=.false.
         CHEMON=.false.
         EDM_ON=.TRUE.
         DBIG=.false.
	 POWER=-1
         NS = 0
         NU = 0
         NT = 0
         NOCC = 0
         NITER = 200
         FORIG = .FALSE.
         FSEMP = .FALSE.
         CAMP = 1.0
         PATTON = .FALSE.
         FLIP = 0.0
         ITERMODE = .false.
         UFLIP2= .false.
         UFLIP3= .false.
         UFLIP4= .false.
         UFLIP5= .false.
         UFLIP6= .false.
         P3F   = .false.
         NSHIFT= .false.
         Owind = .true.
         Pwind = .false.
         STOE=1
         GGMAX = 1.0
         LGCON = .false.
         LNATM = .false.
         NOATM = .false.
         DIVRAND = .true.
         unorm = .false.
         unorm3= .false.
         lshkl = .false.
         tboth_old = .true.
         skipzero=.true.
         DIVT1=.false.
         DIVT2=.false.
         DIVU=.false.
         DIVU2=.false.
         unormu = .false.
C         UESTIM = .false.
C     tests
         DO   J=1,20
           FSTEST(J) = (-1.)
         END DO
C     Default to x-ray
         XRAY = .TRUE.
         CVAR = (-1.)
C     Default parameters for tuning
         TLOG(1) = .FALSE.
         FTUNE(2) = 5.1D0
         FTUNE(1) = 100.
         FTUNE(3) = 0.5D0
         FTUNE(4) = 0.5D0
         ATNUM = (-1.)
C        Change here to 10, was -1
         PATTC = (10.)
         TIMES = 1.
         WIDTH = 1.
         HEIGHT = 1.
         LAT(1) = (-1)
         LAT(2) = (-1)
         BROWNF = .FALSE.  !Why is this true ?
         DMULT = .TRUE.
         DMLT = .FALSE.
         FOM2 = .FALSE.
C       Bumping defaults
        bump=1.0
          do j1=1,10
                do j2=1,10
                        bumpa(j1,j2)=bump
                enddo
                numcord(j1)=0
                numbond(j1)=100
          enddo
        bonding=.false.
        bumper =.false.
        bondcon=.false.
        overbond=.false.
        coord=.false.
        contents=.false.
        coords=.false.
        do j=1,10
            ValAtoms(j)=0
            contmin(j)=0
            contmax(j)=999
        enddo
        BaseCharge=0
        FSTEST(9)=5
 1000    CONTINUE
C     Get the next line
         LINE(1:80) = ' '
         READ (1, 1, ERR=2000, END=2000) LINE
         WRITE (10, 1) LINE
C     Replace commas by blanks, and use upper case
         I1 = ICHAR ('a')
         I2 = ICHAR ('z')
         DO   J=1,80
           DUM = LINE(J:J)
           IDUM = ICHAR (DUM)
           IF (DUM .EQ. '!') THEN
             DO   KK=J+1,80
               LINE(KK:KK) = ' '
               LINE2(KK:KK) = ' '
             END DO
             GO TO 9901
           END IF
           IF (DUM .EQ. ',') DUM = ' '
           IF (IDUM .GT. 126 .OR. IDUM .LT. 32) THEN
             DUM = ' '
             LINE(J:J) = DUM
           ELSE IF (IDUM .GE. I1 .AND. IDUM .LE. I2) THEN
             DUM = CHAR (IDUM - 32)
           END IF
           LINE2(J:J) = DUM
         END DO

    1    FORMAT(A)
C     Get the first character
 9901    NI = 1
         IF (FCHAR4 (LINE2,NI,80,CVAL)) GO TO 1000
         NI = NBLANK (LINE2,NI,80)
         IF (CVAL .NE. 'TITL') THEN
           DO   J=1,80
             LINE(J:J) = LINE2(J:J)
           END DO
         END IF

C     If/then options loop
         IF (CVAL .EQ. 'CELL') THEN
           NH = NBLANK (LINE,NI,80)
           READ (LINE(NH:80), *) WL, CELL
           GO TO 1000
         ELSE IF (CVAL .EQ. 'TWIN') THEN
           TWIN=.true.
         ELSE IF (CVAL .EQ. 'DWRE') THEN
           DWREF = .true.
         ELSE IF (CVAL .EQ. 'PUNT') THEN
           UNORM = .true.
         ELSE IF (CVAL .EQ. 'PUNU') THEN
           UNORMU = .true.
           UNORM  = .true.
         ELSE IF (CVAL .EQ. 'PUNW') THEN
           UNORM3 = .true.
           UNORM  = .true.
C         ELSE IF (CVAL .EQ. 'TNEW') THEN
C           tboth_old = .false.
         ELSE IF (CVAL .EQ. 'ZERO') THEN
           skipzero = .false.
         ELSE IF (CVAL .EQ. 'FLOA') THEN
           CVAR = 1.
         ELSE IF (CVAL .EQ. 'TITL') THEN
           TITLE(1:78) = ' '
           NL = NCHAR (LINE,NI,80)
           NH = NL - 1
           DO   J=NL,80
             IF (LINE(J:J) .EQ. '!') GO TO 1010
             NH = NH + 1
           END DO
           IF (NH .EQ. NL) GO TO 1000
 1010      TITLE(1:NH - NL + 1) = LINE(NL:NH)
           IF (NH - NL + 2 .LE. 80) THEN
             TITLE(NH - NL + 2:80) = ' '
           END IF
         ELSE IF (CVAL .EQ. 'ORIG') THEN
           FORIG = .TRUE.
C     New, divergence amplitude
         ELSE IF (CVAL .EQ. 'CAMP') THEN
           IF (FGET98 (LINE,NI,80,CAMP)) GO TO 1000
           WRITE (10, *) 'Convergence strength ', CAMP
C     New, scale specific U to a particular value
         ELSE IF (CVAL .EQ. 'SHKL') THEN
                IF (FINT (LINE,NI,80,HFIX)) GO TO 1000
                IF (FINT (LINE,NI,80,KFIX)) GO TO 1000
                IF (FGET98 (LINE,NI,80,UFIX)) GO TO 1000
                LSHKL = .true.
                write (10,*) 'Fixing ',HFIX,KFIX,' to U = ',UFIX
         ELSE IF (CVAL .EQ. 'ITMD') THEN
           itermode=.true.
C     New, charge-flipping
         ELSE IF (CVAL .EQ. 'FLIP') THEN
           IF (FGET98 (LINE,NI,80,FLIP)) GO TO 1000
         ELSE IF (CVAL .EQ. 'FLP2') THEN
           UFLIP2=.true.
         ELSE IF (CVAL .EQ. 'FLP3') THEN
           UFLIP3=.true.
         ELSE IF (CVAL .EQ. 'FLP4') THEN
           UFLIP4=.true.
         ELSE IF (CVAL .EQ. 'FLP5') THEN
           UFLIP5=.true.
           IF(FGET98 (LINE,NI,80,STOE))STOE=10
         ELSE IF (CVAL .EQ. 'FLP6') THEN
           UFLIP6=.true.
C          P3F = .true.
         ELSE IF (CVAL .EQ. 'NSHF') THEN
           NSHIFT=.true.
C     New, deactivate EDM peaks interface
         ELSE IF (CVAL .EQ. 'NWIN') Then
           OWind = .false.
         ELSE IF (CVAL .EQ. 'PWIN') THEN
           PWind = .true.
         ELSE IF (CVAL .EQ. 'NEDM') THEN
           EDM_ON=.FALSE.
C     New, turn on patterson trapping
         ELSE IF (CVAL .EQ. 'PATT') THEN
           PATTON = .TRUE.
           WRITE(10,*)'Patterson trapping on'
C     New, power control of input
	 ELSE IF (CVAL .EQ. 'POWE') THEN
           IF (FGET98 (LINE,NI,80,POWER)) GO TO 1000
           IF(POWER.LT.0.5)POWER=-1
           IF(POWER.GT.4.0)POWER=-1
           IF(POWER.LT.0.1)GOTO 1000
           WRITE (10, *) 'Power level ', power


C     ********* TESTS, undocumented
         ELSE IF (CVAL .EQ. 'RSC1') THEN
                RSCL1=.FALSE.
         ELSE IF (CVAL .EQ. 'FIXF') then
                FIXF =.true.
         ELSE IF (CVAL .EQ. 'DSYM') THEN
           DSYM = .true.
         ELSE IF (CVAL .EQ. 'NONE') THEN
           divne = .false.
         ELSE IF (CVAL .eq. 'ALTP') THEN
           altp = .false.
         ELSE IF (CVAL .EQ. 'SLOW') THEN
           SLOW = .true.
           if(fget98(line,ni,80,slw1))then
                slw1=3
                slw2=2
                goto 1000
           endif
         if(fget98(line,ni,80,slw2))slw2=2
         ELSE IF (CVAL .EQ. 'DIV1') THEN
           DIVT1=.true.
           write(10,*)'Divt1 true'
         ELSE IF (CVAL .EQ. 'DIVU') THEN
           DIVU = .true.
         ELSE IF (CVAL .EQ. 'MUST') THEN
           if(fint(line,ni,80,i1))goto 1000
           if(fint(line,ni,80,i2))goto 1000
           nmust=nmust+1
           hmust(nmust)=i1
           kmust(nmust)=i2
         ELSE IF (CVAL .EQ. 'DIVW') THEN
           DIVU2= .true.
           DIVU = .true.
         ELSE IF (CVAL .EQ. 'DIV2') THEN
           DIVT2=.true.
         ELSE IF ((CVAL .EQ. 'LEN1').or.(CVAL .EQ. 'LENT')) THEN
C       Turn on the use of Max Ent mode rather than positivity
           lent1=.true.
         ELSE IF (CVAL .EQ. 'LEN2') THEN
C       Turn on the use of many atoms
           lent2=.true.
         ELSE IF (CVAL .EQ. 'LEN3') THEN
C       Turn 9on the use of sqrt(Number of Atoms)
           lent3=.true.
           lent2=.true.
         ELSE IF (CVAL .EQ. 'LEN4') THEN
C       Turn on analytic continuation of entropy
           lent4=.true.
         ELSE IF (CVAL .EQ. 'LEN5') THEN
C       Turn on renormalization
           lent5=.true.
         ELSE IF (CVAL .EQ. 'LEN6') THEN
C       Remove MaxEnt Window
           lent6=.true.
C       Positivity < mean = 0
         ELSE IF (CVAL .EQ. 'LEN7') THEN
           lent7=.true.
         ELSE IF (CVAL .EQ. 'CZER') THEN
C       Do not zero the C array
           czer=.true.
         ELSE IF (CVAL .EQ. 'CZE2') THEN
           czer =.false.
           czer2=.true.
         ELSE IF (CVAL .EQ. 'CZE3') THEN
C           czer =.false.
C           czer2=.true.
           czer3=.true.
         ELSE IF (CVAL .EQ. 'NDIV') then
           IF (FINT (LINE,NI,80,NDFORCE)) GO TO 1000
         ELSE IF (CVAL .EQ. 'DMAX')then
           DBIG=.true.
         ELSE IF (CVAL .EQ. 'GCON') THEN
           LGCON = .true.
           write (10,*) 'Constant Area scaling used'
C         ELSE IF (CVAL .EQ. 'UEST') THEN
C           UESTIM = .true.
C           write (10,*) 'Recale of estimates'
         ELSE IF (CVAL .EQ. 'DRND') THEN
           DIVRAND = .true.
         ELSE IF (CVAL .EQ. 'ATMS') THEN
           IF (FGET98 (LINE,NI,80,ATOMS)) GO TO 1000           
           write (10,*) 'Atom numbers term',atoms
         ELSE IF (CVAL .EQ. 'NOAT') THEN
           NOATM = .true.
           LNATM = .false.
           write (10,*) 'No Fs2002 atom numbers term'
         ELSE IF (CVAL .EQ. 'STOC') THEN
           chemon=.true.
           BaseCharge=-18
           IF (FGET98 (LINE,NI,80,BaseCharge)) GO TO 1000
           WRITE (10, *) 'Valence constraint ', BaseCharge
           do j=1,ns
              ValAtoms(j)=0
           enddo
           do j=1,ns
              xval=0
              IF (FGET98 (LINE,NI,80,xval)) GO TO 1000
              ValAtoms(j)=nint(xval)
              write(10,*) 'Valence of ',sfacts(j),ValAtoms(j)
           enddo
         ELSE IF (CVAL .EQ. 'NEGL') THEN
           IF (FGET98 (LINE,NI,80,FSTEST(5))) GO TO 1000
           WRITE (10, *) 'Negative level ', FSTEST(5)
         ELSE IF (CVAL .EQ. 'CUTL') THEN
           IF (FGET98 (LINE,NI,80,FSTEST(6))) GO TO 1000
           WRITE (10, *) 'Cut level ', FSTEST(6)
         ELSE IF (CVAL .EQ. 'TOPL') THEN
           FSTEST(7) = 1.
           IF (FGET98 (LINE,NI,80,FSTEST(7))) GO TO 1000
           WRITE (10, *) 'Upper Cut level', FSTEST(7)
         ELSE IF (CVAL .EQ. 'SDEV') THEN
           FSTEST(8) = 2.5D0
           IF (FGET98 (LINE,NI,80,FSTEST(8))) GO TO 1000
           WRITE (10, *) 'Development Speed', FSTEST(8)
         ELSE IF (CVAL .EQ. 'NDEV') THEN
           FSTEST(9) = 5
           IF (FGET98 (LINE,NI,80,FSTEST(9))) GO TO 1000
           WRITE (10, *) 'Development cycles', FSTEST(9) - 1
         ELSE IF (CVAL .EQ. 'SAMP') THEN
           IF (FGET98 (LINE,NI,80,FSTEST(11))) GO TO 1000
           IF (abs(FSTEST(11)) .LT. 2.D0) FSTEST(11) = 2
           WRITE (10, *) ' Sampling ', FSTEST(11)
         ELSE IF (CVAL .EQ. 'EWTS') THEN
           WT2ON = .TRUE.
C         ELSE IF (CVAL .EQ. 'PWTS') THEN
C           FSTEST(15) = 2.
C           WRITE (10, *) 'Positivity Weights'
         ELSE IF (CVAL .EQ. 'PEXT') THEN
C     Change values for simple phase extnsion
           FSTEST(5) = 1.
           FSTEST(6) = 0.15D0
           FSTEST(7) = 1.
           FSTEST(8) = 2.
           FSTEST(9) = 2.
         ELSE IF (CVAL .EQ. 'LATT') THEN
           IF (FINT (LINE,NI,80,LAT(1))) GO TO 1000
           IF (FINT (LINE,NI,80,LAT(2))) GO TO 1000
           write(10,*)'Lattice Used ',lat
C           BROWNF = .FALSE.
         ELSE IF (CVAL .EQ. 'NBRN') THEN
           BROWNF = .false.
         ELSE IF (CVAL .EQ. 'MISS') THEN
           BROWNF = .true.
         ELSE IF (CVAL .EQ. 'MULT') THEN
           DMULT = .TRUE.
         ELSE IF (CVAL .EQ. 'MUL2') THEN
           DMLT = .TRUE.
C         ELSE IF (CVAL .EQ. 'FOM2') THEN
C           FOM2 = .TRUE.
C         ELSE IF (CVAL .EQ. 'ZERO') THEN
C           FSTEST(14) = 2.
C           WRITE (10, *) 'Include zero'
C     Bonding related
      else if(cval.eq.'BUMC')then
         bumper=.true.
         if(fget98(line,ni,80,bump))bump=1.25
C       Set values for array using ns
           do j1=1,ns
                do j2=1,ns
                        bumpa(j1,j2)=bump
                enddo
           enddo
        else if(cval.eq.'BUMP')then
C       Array of bumping values
        bumper=.true.
           do j1=1,ns
                do j2=j1,ns
            if(fget98(line,ni,80,bump))bump=1.25
                        bumpa(j1,j2)=bump
                        bumpa(j2,j1)=bump
                write(10,*)'Bumping constraint between ',sfacts(j1),
     1      sfacts(j2),' is ',bump
                enddo
           enddo
        else if(cval.eq.'BNDC')then
           bondcon=.true.
        else if(cval.eq.'BOND')then
        bonding=.true.
           do j1=1,ns
                do j2=j1,ns
            if(fget98(line,ni,80,bump))bump=1.25
                        bonda(j1,j2)=bump
                        bonda(j2,j1)=bump
                write(10,*)'Bonding distance between ',sfacts(j1),
     1      sfacts(j2),' is ',bump
                enddo
           enddo
        else if(cval.eq.'COOR')then
C       Co-ordination numbers
        coord=.true.
        do j1=1,ns
            if(fint(line,ni,80,numcord(j1)))numcord(j1)=1
            write(10,*)'Minimum Co-ordination of ',sfacts(j1),
     1      ' is ',numcord(j1)
        enddo
        else if(cval.eq.'COOM')then
C       Max Co-ordination numbers
        overbond=.true.
        do j1=1,ns
            if(fint(line,ni,80,numbond(j1)))numbond(j1)=999
            write(10,*)'Maximum Co-ordination of ',sfacts(j1),
     1      ' is ',numbond(j1)
        enddo

C     ********* TESTS
         ELSE IF (CVAL .EQ. 'VERB') THEN
           PRINTF = .TRUE.
         ELSE IF (CVAL .EQ. 'SEMP') THEN
           FSEMP = .TRUE.
         ELSE IF (CVAL .EQ. 'WIND') THEN
           IF (FCHAR (LINE,NI,80,CVAL)) GO TO 1000
           IF (CVAL(1:3) .EQ. 'OFF') PMASK = .FALSE.
         ELSE IF (CVAL .EQ. 'NORM') THEN
           IF (FCHAR (LINE,NI,80,CVAL)) GO TO 1000
           IF (CVAL(1:3) .EQ. 'OFF') PCOR = (-1.)
         ELSE IF (CVAL .EQ. 'ITER') THEN
           IF (FINT (LINE,NI,80,NITER)) GO TO 1000
           IF (NITER .LT. 1) NITER = 999
         ELSE IF (CVAL .EQ. 'SFAC') THEN
C     Read in the Atom names
           NS = 0
  100      NS = NS + 1
           IF (.NOT.FCHAR (LINE,NI,80,SFACTS(NS))) THEN
C           write(10,*)'Got: ',sfacts(ns)
             IF (SFACTS(NS) .EQ. '    ') GO TO 101
             GO TO 100
           END IF
  101      NS = NS - 1
           IF (NS .EQ. 0) THEN
             WRITE (6, 1) 'ERROR: No atom types'
             GO TO 999
           END IF
         ELSE IF (CVAL .EQ. 'UNIT') THEN
C     Read in the number of each type of atom
           NU = 0
  200      NU = NU + 1
           IF (FINT (LINE,NI,80,NCONT(NU))) GO TO 201
           GO TO 200
  201      NU = NU - 1
           IF (NU .EQ. 0) THEN
             WRITE (6, 1) 'ERROR: No contents'
             GO TO 999
           END IF
         ELSE IF (CVAL .EQ. 'TFAC') THEN
C     Read in the temperature factors for each type of atom
           NT = 0
  300      NT = NT + 1
           IF (FGET98 (LINE,NI,80,TEMPF(NT))) GO TO 301
           GO TO 300
  301      NT = NT - 1
         ELSE IF (CVAL .EQ. 'AOCC') THEN
C     Read in occupancies for each type of atom
           NOCC = 0
  302      NOCC = NOCC + 1
           IF (FGET98 (LINE,NI,80,AOCC(NOCC))) GO TO 303
           GO TO 302
  303      NOCC = NOCC - 1
         ELSE IF (CVAL .EQ. 'ATOM') THEN
C     Minimum number of peaks constraint
           IF (FGET98 (LINE,NI,80,ATNUM)) ATNUM = (-1.)
         ELSE IF (CVAL .EQ. 'TEST') THEN
C     Testing input -- use -1
           IF (FGET98 (LINE,NI,80,PATTC)) PATTC = -1.
         ELSE IF (CVAL .EQ. 'SYMM') THEN
           IF (FCHAR (LINE,NI,80,SYMM)) THEN
             WRITE (6, 1) 'ERROR: Symmetry cannot be read'
             GO TO 999
           END IF
C     translate symmetry to lower case
           I1 = ICHAR ('A')
           I2 = ICHAR ('Z')
           DO   J=1,4
             IDUM = ICHAR (SYMM(J:J))
             IF (IDUM .LE. I2 .AND. IDUM .GE. I1) SYMM(J:J) = CHAR (IDUM
     X           + 32)
           END DO
         ELSE IF (CVAL(1:3) .EQ. 'END') THEN
           GO TO 2000
C
C     Model options
         ELSE IF (CVAL .EQ. 'MDL0') THEN
                modelmode = .true.
                modelog1  = .false.
                modelog2  = .false.
           IF (FGET98 (LINE,NI,80,cutmodel)) cutmodel=0.5
         ELSE IF (CVAL .EQ. 'MDL1') THEN
                modelmode = .true.
                modelog1  = .true.
                modelog2  = .false.
           IF (FGET98 (LINE,NI,80,cutmodel)) cutmodel=0.5
          ELSE IF (CVAL .EQ. 'MDL2') THEN
                modelmode = .true.
                modelog1  = .false.
                modelog2  = .true.
           IF (FGET98 (LINE,NI,80,cutmodel)) cutmodel=0.5
            ELSE IF (CVAL .EQ. 'MDL3') THEN
                modelmode = .true.
                modelog1  = .true.
                modelog2  = .true.
           IF (FGET98 (LINE,NI,80,cutmodel)) cutmodel=0.5
          ELSE IF (CVAL .EQ. 'MODE') THEN
C     Mode to use
           IF (FCHAR (LINE,NI,80,CVAL)) GO TO 1000
           IF (CVAL .EQ. 'ENTR') THEN
             FTUNE(2) = 3.1D0
           ELSE IF (CVAL .EQ. 'POSI') THEN
             FTUNE(2) = 4.1D0
             positivity = .true.
C            FixPosScl  = .true.
C            FSTEST(9) = max(FSTEST(9),8.)
             FLIP = max(flip,1.0)
           ELSE IF (CVAL .EQ. 'MIXE') THEN
             FTUNE(2) = 5.1D0
           ELSE IF (CVAL .EQ. 'EQUA') THEN
             FTUNE(2) = 0.9D0
           ELSE IF (CVAL .EQ. 'TES1') THEN
             FTUNE(2) = 6.1D0
           ELSE IF (CVAL .EQ. 'TES2') THEN
             FTUNE(2) = 7.1D0
           END IF
         ELSE IF (CVAL .EQ. 'FIXP') THEN
C     Fix positivity scale to 1
           FixPosScl = .true.
         ELSE IF (CVAL .EQ. 'PLAM') THEN
C     Encode Positivity Lambda
           IF (FGET98 (LINE,NI,80,X)) GO TO 1000
           IF (X .LT. 0.D0) THEN
             WRITE (10, 1) 'Invalid Positivity Lambda'
             WRITE (10, 1) 'Using Default value'
             GO TO 1000
           ELSE IF (X .GT. 5.D0) THEN
             WRITE (10, 1) 'Invalid Positivity Lambda'
             WRITE (10, 1) 'Using Default value'
             GO TO 1000
           END IF
           FTUNE(4) = X - 1
         ELSE IF (CVAL .EQ. 'LAMB') THEN
C     Encode phase lambda
           IF (FGET98 (LINE,NI,80,X)) GO TO 1000
           IF (X .LT. 0.D0) THEN
             WRITE (10, 1) 'Invalid Lambda'
             WRITE (10, 1) 'Using Default value'
             GO TO 1000
           ELSE IF (X .GT. 5.D0) THEN
             WRITE (10, 1) 'Invalid Lambda'
             WRITE (10, 1) 'Using Default value'
             GO TO 1000
           END IF
           FTUNE(3) = X - 1
           FTUNE(1) = 1 + FTUNE(3)
           IF (.NOT.FGET98 (LINE,NI,80,X)) THEN
C     Trap X very small as AUTO
C             IF (ABS(X) .LT. 1D-3) THEN
C               FTUNE(1) = 100.
             IF (X .LT. 1d-2) THEN
C     Fixed value
               FTUNE(1) = 1 + FTUNE(3)
               GO TO 1000
             ELSE IF (X .GT. 5.D0) THEN
               WRITE (10, 1) 'Invalid Turnon Speed'
               WRITE (10, 1) 'Using Default value'
               GO TO 1000
             ELSE
C     Increasing value
               FTUNE(1) = 10 + X
             END IF
             GO TO 1000
           END IF
C       See if AUTO is encoded
           IF (FCHAR (LINE,NI,80,CVAL)) GO TO 1000
           IF (CVAL .EQ. 'AUTO') FTUNE(1) = 100.
         ELSE IF (CVAL .EQ. 'ELEC') THEN
C     Electron Scattering factors ?
           XRAY = .FALSE.
C     Variables for final diplay
C     Width
         ELSE IF (CVAL .EQ. 'WIDT') THEN
           IF (FGET98 (LINE,NI,80,WIDTH)) WIDTH = 1.
           IF (WIDTH .LT. 0) WIDTH = 1.
           IF (WIDTH .GT. 10) WIDTH = 10.
C     Height
         ELSE IF (CVAL .EQ. 'HEIG') THEN
           IF (FGET98 (LINE,NI,80,HEIGHT)) HEIGHT = 1.
           IF (HEIGHT .LT. 0) HEIGHT = 1.
           IF (HEIGHT .GT. 10) HEIGHT = 10.
C     Magnification
         ELSE IF (CVAL .EQ. 'TIME') THEN
           IF (FGET98 (LINE,NI,80,TIMES)) TIMES = 1.
           IF (TIMES .LT. 0) TIMES = 1.
           IF (TIMES .GT. 4) TIMES = 8.
         END IF
C     Ignore other lines
         GO TO 1000
 2000    CONTINUE
 
C     Traps
         IF (NS .NE. NU) THEN
           WRITE (6, 1) 'Number of Atoms and Names do not match'
           write(6,*)'Found ',ns,nu
           GO TO 999
         END IF
C     Get rid of overjealous temperature factors
         IF (NS .LT. NT) NT = NS
C     Setup a default of 0.5 if not given for temperature factors
         IF (NS .GT. NT) THEN
           DO   J=NT+1,NS
             TEMPF(J) = 0.5D0
           END DO
           NT = NS
         END IF
         NATOM = NT
C     Get rid of overjealous occupancies
         IF (NS .LT. NOCC) NOCC = NS
C     Setup a default of 1 if not given for occupancies
         IF (NS .GT. NOCC) THEN
           DO   J=NOCC+1,NS
             AOCC(J) = 1.
           END DO
           NT = NS
         END IF
         NATOM = NT
C     close(unit=1)
C       Trap origin with model
         if(modelmode)forig=.false.
         RETURN
  999    WRITE (6, 1) 'Died due to bad input'
         WRITE (10, 1) 'Died due to bad input'
         CALL EXIT    (0)
       END
