C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPFLIP (N1, N2, M, C, IOPT, X1, X2 )
         COMPLEX C(*)
         INTEGER M(3), N1, N2, IOPT
         DOUBLEPRECISION XMEAN, XR, XI
         DOUBLEPRECISION XT,BCUT, XFLIP
         real XWORK(N1*N2)
         include 'NewStuff.h'
         LOGICAL  UFLIP
C     Positivity constraint as well
C     Do a FFT
C        write(10,*)'Debug ',X1
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip  .gt. 1e-4)then
                uflip=.true.
                XFLIP=FLIP/DBLE(N1*N2)
         else
                XFLIP=1./DBLE(N1*N2)
         endif
         if(uflip2)XFLIP=GGMAX*XFLIP
C
        INCLUDE 'EntScales.h'
         JK = 0
         MF = (-1)
         XLMAX=-1
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF (XT .gt. XLMAX) XLMAX=XT
             SUMSQ=SUMSQ+XT*XT
             work(JK)=XT             
           ENDDO
         ENDDO
        XFLIP = XLMAX*XFCUT*FLIP
C
        sum = 0
        sum2= 0
        sumsq=0
        sumsq2=0
        DO J=1,n1*n2
                IF(XWORK(J) .gt. XFLIP)then
                        sum=sum+xwork(j)
                        sumsq=sumsq+xwork(j)*xwork(j)
                else
                        sum2=sum2-xwork(j)
                        sumsq2=sumsq2+xwork(j)*xwork(j)
                endif
        enddo
C
C       Want f1, f2 such that
C       f1*sum   + f2*sum2   = sum - sum2
C       f1*sumsq + f2*sumsq2 = sumsq + sumsq2
        det = sum*sumsq2 - sum2*sumsq
        a11 = sum
        a12 = sum2
        a21 = sumsq
        a22 = sumsq2
        f1 = ( a22*(sum-sum2)-a12*(sumsq+sumsq2))/det
        f2 = (-a12*(sum-sum2)+a22*(sumsq+sumsq2))/det
C
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF (XT .LT. BCUT ) THEN
                        XR = 0.D0
             ELSE
                        XR = XT * LOG (XT/XMEAN)
             END IF
             if(XT .lt. XFLIP) then
                XI = -XT*f2
             else
                XI =  XT*f1
             endif
             IF(NF .LT. 0)then
                XR = - XR
                XI = - XI
             ENDIF 
             C(JK) = CMPLX (XR, XI)
           END DO
         END DO
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
 
