/*
 * mbu_intrct.c
 *  interactive mode
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "mbconfig.h"
#include "fitting.h"
#include "mb_input.h"
#include "data_out.h"
#include "mb_sim.h"
#include "ts_scan.h"
#include "e_density.h"
#include "mbu_output.h"

#define  BUFSIZE  256


extern  DEBUG_INFO	dbg;
extern  EPS_CTRL	epsilon;


void mbutl_interactive(void)
{
  int  i;
  char  buf[BUFSIZE];

  printf("\n");
  printf("  ***********************************\n");
  printf("  ***** mbutl: interactive mode *****\n");
  printf("  ***********************************\n\n");

  printf(" 1. ASSIST: for making a mbutl-script file.\n");
  printf(" 2. TMP:.\n");
  printf(">>");
  i = fget_i(stdin);

  if(i == 1){
    printf("1. ASSIST mode\n");
  }
  else if(i == 2){
    printf("2. TMP mode\n");
  }
  else{
    printf("$$ Invalid number. Abort.\n");
    exit(EXIT_FAILURE);
  }
}
