/*
 * vecmat.h
 */

/* #include <stdlib.h> */

/* version 1 */
/*
#define P1(a) 
#define P2(a,b) 
#define P3(a,b,c) 
#define P4(a,b,c,d)

#define new_vector(tp, n)     ((tp *) malloc( (n) * sizeof(tp) ))
#define new_matrix(tp,n1,n0) ((tp **) mmalloc( (n1), (n0) * sizeof(tp) ))
#define new_tensor(tp,n2,n1,n0)     \
	((tp ***) mmmalloc( (n2), (n1), (n0)* sizeof(tp) ))
#define new_tensor4(tp,n3,n2,n1,n0)     \
	((tp ****) mmmmalloc( (n3), (n2), (n1), (n0) * sizeof(tp) ))
#define free_vector(x)	free(x)

void **   mmalloc(P2(size_t n1, size_t n0              ));
void ***  mmmalloc(P3(size_t n2, size_t n1, size_t n0  ));
void **** mmmmalloc(P4(size_t n3, size_t n2, size_t n1, size_t n0 ));

void chk_vector( void *x );
void chk_matrix( void **x );
void chk_tensor( void ***x );
void chk_tensor4( void ****x );

void free_vector(P1(void *));
void free_matrix(P1(void *));
void free_tensor(P1(void *));
void free_tensor4(P1(void *));
*/

/* version 2 on 18 Oct. 2000 */
#define new_vector(tp, n)  ( (tp *)malloc((n)*sizeof(tp) ) )
#define new_matrix(tp,n1,n0)  ( (tp **)mmalloc((n1),(n0)*sizeof(tp)) )
#define new_tensor(tp,n2,n1,n0)  ( (tp ***)mmmalloc((n2),(n1),(n0)*sizeof(tp)) )
#define new_tensor4(tp,n3,n2,n1,n0)  \
  ( (tp ****)mmmmalloc((n3),(n2),(n1),(n0)*sizeof(tp)) )
#define free_vector(x)  free(x)

void **mmalloc(size_t n1, size_t n0);
void ***mmmalloc(size_t n2, size_t n1, size_t n0);
void ****mmmmalloc(size_t n3, size_t n2, size_t n1, size_t n0);
/*
void chk_vector( void *x );
void chk_matrix( void **x );
void chk_tensor( void ***x );
void chk_tensor4( void ****x );
*/
void chk_vector( void * );
void chk_matrix( void * );
void chk_tensor( void * );
void chk_tensor4( void * );

/*
void free_matrix(void **x);
void free_tensor(void ***x);
void free_tensor4(void ****x);
 */
void free_matrix(void *);
void free_tensor(void *);
void free_tensor4(void *);


/*
#define new_tensor4_element(n3)    (void ****) malloc( (n3) * sizeof(void ***))
#define new_tensor_element(n2)     (void  ***) malloc( (n2) * sizeof(void **))
#define new_matrix_element(n1)     (void   **) malloc( (n1) * sizeof(void *))
#define new_vector_element(tp, n)  ((tp *) malloc( (n)  * sizeof(tp) ))
 */
/* You should add 'cast' */
#define new_tensor4_element(n3)    malloc( (n3) * sizeof(void ***) )
#define new_tensor_element(n2)     malloc( (n2) * sizeof(void **) )
#define new_matrix_element(n1)     malloc( (n1) * sizeof(void *) )
#define new_vector_element(tp, n)  ( (tp *) malloc( (n) * sizeof(tp) ) )
