#ifndef __CAtomRefinementDialog__
#define __CAtomRefinementDialog__

#include <Dialogs.h>
#include "CCrystal.h"
extern short	gNumActiveElements ;
extern short 	gActiveElementNumber[20] ;	// Maximum number of active elements

void DeleteRefinementList(RefinementList *list) ;
#include "CAtomRefinementListBox.h"

#define kAtomRefinementDialogID	152
class CAtomRefinementDialog {

	public:
		CAtomRefinementDialog() ;
		~CAtomRefinementDialog() ;
		void SetAtomListData(CCrystal *crystal,RefinementList *list) ;
		void GetAtomListData(CCrystal *crystal,RefinementList *list) ;
		Boolean DoEvents() ;
		Boolean IsValid(void) { return (mDialog != nil ? true : false ) ; } ;
		CAtomRefinementListBox *GetAtomList(void) {  return mAtomList ; } ;
	private:
		DialogPtr mDialog ;
		CAtomRefinementListBox *mAtomList ;
		RefinementList	*mList ;
		static pascal Boolean DialogFilter(DialogPtr tp,EventRecord *theEvent,short *itemHit) ;
		GrafPtr	mSavedPort ;
		ModalFilterUPP	mModalFilter ;
		static Point	mMouseLoc ;
		CCrystal *mCrystal ;
		Boolean	mXAllOn ;
		Boolean	mYAllOn ;
		Boolean	mZAllOn ;
		Boolean	mDWAllOn ;
		Boolean	mOCCAllOn ;
} ;


#endif

