// CRefConListBox.h
// Created by Roar on Thu, Aug 3, 1995 @ 10:14 PM.

#ifndef __CRefConListBox__
#define __CRefConListBox__

#include <Lists.h>

#include "RefConLDEF.h"

typedef void (*ListElementProc)(Rect *cellRect, Cell lCell, ListHandle theList, long refCon) ;

class CRefConListBox  
{
public:

	CRefConListBox() ;
	CRefConListBox(WindowPtr window,Rect &rect) ;
	virtual 	~CRefConListBox();
	void		SetDrawProc(ListElementProc listElementProc)  ;
	void		SetCell(void *data,Cell &theCell) ;
	void		GetCell(long **data,Cell &theCell) ;
	void		AddRow(int count, int afterRow) ;
	ListHandle	GetListHandle(void) { return mListH ; } ;
	
private:
	void					ClickSelf(EventRecord	&event);
	RefconLDEFDrawProcUPP 	mListElementProcUPP ;
	RefconLDEFCell			mCellData;
	ListHandle				mListH ;
	Rect					mRect ;

};

#endif

