#ifndef THelpWindow__h
#define THelpWindow__h

class THelpWindow {

public:
		THelpWindow(short windowResID,short helpResID) ;
		~THelpWindow(void) ;


		static pascal void	HandlehelpWindowScrollBar(ControlHandle control,short partCode)	;
		
		void			Draw(void) ;
		void			DoEvent(EventRecord *theEvent) ;
		Boolean			IsValid(void) { return mIsValid ; } ;
		WindowPtr		GetWindow(void) { return mWPtr ; } ;
		
	private:
		void			DoMouseDown(EventRecord *event) ;
		void			DoMouseDownInContent(EventRecord *event) ;
		Boolean			mIsValid ;
		ControlActionUPP mScrollBarUPP ;
		short			mCurrentSelectedItem ;
		short			mHelpResourceNumberID ;
		short			*mHelpResourceNumber ;
		short			mNumHelpFunctions ;
		short			mScrollBarMin ;
		short			mScrollBarMax ;
		Rect			mHelpTextRect ;
		Rect			mFunctionListRect ;
		RgnHandle		mListRgn ;
		WindowPtr 		mWPtr ;
		ControlHandle	mHelpWindowScrollBar ;
		ControlHandle	mListScrollBar ;
		ListHandle		mFunctionListHandle ;
		ControlHandle	mDismissButton ;
		TEHandle		mHelpTextHandle ;
		StScrpHandle 	mHelpTextStyleHandle ;
} ;

#endif

