// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
extern MENUS cmndptrs[] ;
extern FPV funcpntrs[] ;
extern long DIFFRPT,IMAGE_MODE,no_cmnd ;
// --------------------------------------------------------------------------
// Set-up routine. Invoked by the "FFT" command in the DISPLAY menu 
// --------------------------------------------------------------------------
void r_fft() {

	eraser(0,0,1020,32) ;
	cmndptrs[no_cmnd] = gCurrentButton ;
	if (!DIFFRPT) {
		DIFFRPT = TRUE ; IMAGE_MODE = FALSE ; 
		funcpntrs[no_cmnd++] = (FPV)cfft ;
	}
	else {
		DIFFRPT = FALSE ; IMAGE_MODE = TRUE ;
		funcpntrs[no_cmnd++] = (FPV)cfftinv ;
	}
	on_highlight() ;
}

