// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "menudef.h"
#include <string.h>
#include <ctype.h>

extern struct MicroscopeRec {
                char name[10] ;
                float v ;
                float cs ;
                float del ;
                float th ;
              } microscope[] ;
long set_microscope(char *string) {
	long i,istat,index ;
	char *cp,*cp1 ;

	/* We check the microscope name in string[] against the list of
	microscopes and return the index into the array. Return -1 if no match.
	*/
	index = -1 ;
	cp = string ;
	cp1 = string ;
	while ((*cp++ = toupper(*cp1++))) ;
	for (i=0;i<NUM_MICROSCOPES;i++) {
		istat = strcmp(string,microscope[i].name) ;
		if (istat == 0) {
			index = i ;
			break ;
		}
	}
	return(index) ;
}

