#include <stdio.h>
extern struct { 	long np,mp ;
		char title[80] ;
		char file[30] ;
} IMAG_FILE ;
void wrt_image(unsigned char *image,long *ierror) ;
// ----------------------------------------------------------------	
// Routine to write an image stored from the display (wrt_image)	
// ----------------------------------------------------------------	
void wrt_image(unsigned char *image,long *ierror) {
    long numPts ;
    FILE *fp ;

    *ierror = 0 ;
    if ((fp = fopen(IMAG_FILE.file,"w")) == NULL) {
    	*ierror = 1 ;
    	return ;
    }
    if (fwrite(&IMAG_FILE.np,sizeof(long),2,fp) != 2) {
    	*ierror = 3 ;
    	fclose(fp) ;
    	return ;
    }
    if (fwrite(IMAG_FILE.title,80*sizeof(char),1,fp) != 1) {
    	*ierror = 3 ;
    	fclose(fp) ;
    	return ;
    }
    numPts = IMAG_FILE.np*IMAG_FILE.mp ;
    if (fwrite(image,numPts*sizeof(char),1,fp) != 1) {
    	*ierror = 3 ;
    	fclose(fp) ;
    	return ;
    }
    fclose(fp) ;
}
