//LDM added - since it is used
#define nil     0
#include "CImage.h"
#include "TImage.h"

template<class T>
CImage<T>::CImage(short w,short h, T *data,float angle) {
	mWidth = w ;
	mHeight = h ;
	mGamma = angle ;
	long	length = w*h ;
	mData = new T[length] ;
	if (data != nil)
		memcpy(mData,data,length*sizeof(T)) ;
}

template<class T>
CImage<T>::~CImage() {
	if (mData != nil)
		delete[] mData ;
}

template<class T>
void CImage<T>::Print() {
	Cmplx c = 2. ;
	Cmplx v = 1. ;
	Cmplx r ;
	r = c+v ; 
	fprintf(stderr," (%.1f,%.1f) + (%.1f,%.1f) = (%.1f,%.1f)\n",
		c.Real(),c.Imag(),v.Real(),v.Imag(),r.Real(),r.Imag()) ;
	r = c-v ;
	fprintf(stderr," (%.1f,%.1f) - (%.1f,%.1f) = (%.1f,%.1f)\n",
		c.Real(),c.Imag(),v.Real(),v.Imag(),r.Real(),r.Imag()) ;
	r = c*v ;
	fprintf(stderr," (%.1f,%.1f) * (%.1f,%.1f) = (%.1f,%.1f)\n",
		c.Real(),c.Imag(),v.Real(),v.Imag(),r.Real(),r.Imag()) ;
	r = c/v ;
	fprintf(stderr," (%.1f,%.1f) / (%.1f,%.1f) = (%.1f,%.1f)\n",
		c.Real(),c.Imag(),v.Real(),v.Imag(),r.Real(),r.Imag()) ;

	Cmplx t(1.,1.) ; c = t ;
	fprintf(stderr,"c = (%.1f,%.1f)\n",c.Real(),c.Imag()) ;
	c += 2. ;
	fprintf(stderr,"c = (%.1f,%.1f)\n",c.Real(),c.Imag()) ;
	c *= 2. ;
	fprintf(stderr,"c = (%.1f,%.1f)\n",c.Real(),c.Imag()) ;
	c /= 4. ;
	fprintf(stderr,"c = (%.1f,%.1f)\n",c.Real(),c.Imag()) ;
	c -= t ;
	fprintf(stderr,"c = (%.1f,%.1f)\n",c.Real(),c.Imag()) ;
	//for(int i = 0; i < mWidth*mHeight; i++) {
	//	fprintf(stderr,"%d ",mData[i]) ;
	//	if (i%8 == 0)
	//		fprintf(stderr,"\n") ;
	//}
}
