#ifndef __TRuler_h
#define __TRuler_h
#include "TVector.h"
#include "TBaseObject.h"
#include "XDrivers.h"
class	TImageWindow ;
class	TImage ;

class	TRuler : public TBaseObject {
	public:
		TRuler(Point &pt,TImageWindow *window) ;
		TRuler() 		{} ;
		virtual 		~TRuler() {} ;
		virtual	void	Draw() ;
		virtual	void	DoMouseDown(Point &pt) ;
		virtual	bool	InRuler(Point &pt) ;
        virtual void	Shift(short dx, short dy) ;
        virtual	float	GetLength() ;    
        virtual	float	GetAngle() ;   
        // TRuler			*Copy()  { TRuler *ruler = new TRuler ; *ruler = *this ; return ruler ; } ; 
        TBaseObject			*Copy()  { TRuler *ruler = new TRuler ; *ruler = *this ; return (TBaseObject *)ruler ; } ; 
        bool			IsValid() { return mIsValid ; } ;
        bool			IsSelected() { return mIsSelected ; } ;
		void			Select(Boolean state) { mIsSelected = state ; } ;
		void			SetWindow(TImageWindow *window) { mWindow = window ; } ;
		void			ShowInfo() ;
	protected:
		virtual	void	DrawHandles() ;
		virtual	bool	InHandles(Point &pt) ;
		virtual	void	Modify(Point &pt) ;
		FPoint			mEndPoint1 ;
		FPoint			mEndPoint2 ;
		bool			mIsSelected ;
		bool			mIsValid ;
		TImageWindow	*mWindow ;
} ;

#endif

