#ifndef __GLOBALS__
#define __GLOBALS__
#include <stdio.h>
#include "types.h"
#include "devices.h"
#include "TWindow.h"

#ifdef __MAIN__
GDevice	*gOutDevice = &WorkStation;
GDevice	  gOutDisplay  ;
Cursor	     gWatchCursor ;

CharRecord CharRc 	= {"Times-Roman",8,8} ;
GrayLevel gGrayLevel 	= kWhite  ;
OrRelation gOrRelation 	= kDirPlane ;
CursorMode gCursorMode	= kNormalCursor ;

short 		gPatIndex ;
short		gDisplayWidth,gDisplayHeight ;
Point 		gMouseDownLoc ;
short		gOvalSize =15 ;	
short		gThreeDBalls= 0 ;
PtDefined 	gWhatDefined = kNothing ;
AtomDef		gWAtom = kFirstAtom ;
GrafPtr		gCurrentPort ;
GrafPtr		gSavedPort ;
OffScreenPtr	gOffscreenPtr ;
TWindow		*gDisplayWindow,*gControlWindow ;
Display 	*gDisplay ;
char		gCurrentText[132] = {'\0'} ;
char		gInfoString[132] = {'\0'} ;
char		gPostscriptFileName[132] = {'p','s','.','p','s','\0'} ;
short		gPostscriptToFile = 0 ;
short		gCustomMontage = 0 ;
int		gScreen ;
Colormap	gColorMap ;
XFontStruct	*gFontStructure ;
XSetWindowAttributes	gImageAttributes ;
XVisualInfo	gVisualInfo ;
XWindowAttributes	myWindowAttributes ;
XColor		gColors[512] ;
unsigned long 	gBlackPixel ;
unsigned long 	gWhitePixel ;
unsigned long 	gRedPixel ;
unsigned long 	gGreenPixel ;
unsigned long 	gBluePixel ;
unsigned long 	gGrayPixel ;
unsigned long 	gDarkerGray ;
unsigned long 	gLighterGray ;
unsigned long 	gDarkGray ;
unsigned long 	gForegroundColor ;
unsigned long 	gBackgroundColor ;
unsigned char	*gImageLineBuffer ;
XImage		*gImageLine,*gImage ;
Time		gTickTime,gAtomTime ;
short		gDoneFlag = 0 ;
short		gHasAdvertised = 0 ;
long  		gCurx,gCury ;
Point		gCurrentTextPos ;
Rect		gCommandLineRect = {5,547,745,570} ;
struct	{
	int automatic ;
	float amin ;
	float amax ;
	float pmin ;
	float pmax ;
} gScaling = {1,0.,1.,-3.1415927/2,3.1415927/2.} ;
short	gPrintValues = 0 ;
short	gSubMeanPhase=1 ;
float	gMagnification=1 ;
FILE	*gPSFile ;
#else
extern float		gMagnification ;
extern short		gOvalSize ;			 
extern short		gThreeDBalls ;
extern PtDefined 	gWhatDefined ;
extern AtomDef		gWAtom ;
extern	char		gCurrentText[] ;
extern	char		gInfoString[] ;
extern  char		gPostscriptFileName[132] ;
extern  short		gPostscriptToFile ;
extern  short		gCustomMontage ;
extern	OffScreenPtr		gOffscreenPtr ;
extern	GrafPtr 	gCurrentPort ;
extern	GrafPtr		gSavedPort ;
extern	GrafPtr		gSavedPort ;
extern	TWindow		*gDisplayWindow,*gControlWindow ;
extern	Display 	*gDisplay ;
extern	int		gScreen ;
extern	Colormap	gColorMap ;
extern	XFontStruct	*gFontStructure ;
extern	XSetWindowAttributes	gImageAttributes ;
extern	XWindowAttributes	myWindowAttributes ;
extern	XVisualInfo	gVisualInfo ;
extern	XColor		gColors[168] ;
extern	unsigned long 	gBlackPixel ;
extern	unsigned long 	gWhitePixel ;
extern	unsigned long 	gRedPixel ;
extern	unsigned long 	gGreenPixel ;
extern	unsigned long 	gBluePixel ;
extern	unsigned long 	gGrayPixel ;
extern	unsigned long 	gDarkerGray ;
extern	unsigned long 	gDarkGray ;
extern	unsigned long 	gLighterGray ;
extern	unsigned long 	gForegroundColor ;
extern	unsigned long 	gBackgroundColor ;
extern	XImage		*gImageLine,*gImage ;
extern	Time		gTickTime,gAtomTime ;
extern	short		gDoneFlag ;
extern	short		gHasAdvertised ;
extern	unsigned	char	*gImageLineBuffer ;
extern	long		gCurx,gCury ;
extern	Rect		gCommandLineRect ;
extern	Point		gCurrentTextPos ;
extern	short		gDisplayWidth,gDisplayHeight ;
extern FILE		*gPSFile ;
extern GDevice	*gOutDevice ;
extern GDevice	  gOutDisplay ;
extern Cursor gWatchCursor ;
extern  struct {
	int automatic ;
	float amin,amax,pmin,pmax ; 
} gScaling ;
extern CharRecord 	CharRc ;
extern GrayLevel 	gGrayLevel ;
extern OrRelation 	gOrRelation ;
extern CursorMode 	gCursorMode ;

extern  short gPrintValues ;
extern  short gSubMeanPhase ;
#endif /* __MAIN__ */
#endif /* __GLOBALS__ */
