C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION TB2DC (IH, K, FHK, AHK, AIN, NREF, NCN, CFLAG, SYMM,
     X    NBEAMS, NHK, C, M, IOPT, FRCALC,FWT,NUSE)
C
C
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         dimension fmodel(NHK2),amodel(nhk2)
         INCLUDE 'NewStuff.h'
         INCLUDE 'TModel.h'
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC, Centref(nhk2)
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         DIMENSION IH(*), K(*), FHK(*), AHK(*), AOLD(NHK2), 
     X   AIN(*)
         DIMENSION FRCALC(*), FICALC(NHK2), ARCALC(NHK2)
         DIMENSION AICALC(NHK2)
         DIMENSION WR(NHK2), WI(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*)
         COMPLEX*16 W1, W2, RES1, RES2
         real*8 res1A(2), res2A(2)
         equivalence (res1,res1A), (res2,res2A)
         DOUBLEPRECISION BRSUM, BISUM, PI, PI2
         DOUBLEPRECISION ACONV, ANG, FSQ
         DOUBLEPRECISION COSAN, SINAN, F, AISUM, ARSUM
         LOGICAL CFLAG
         CHARACTER*4 SYMM
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         DOUBLEPRECISION Third, OFFSET
         PARAMETER (Third = 1.D0 / 3.D0, OFFSET=1.0D0)
         LOGICAL P3FLAG
         COMPLEX*16 ComplexHalf
         PARAMETER (ComplexHalf = 1.D0/(0.D0,2.D0))
C        Window Rescaling
         Include 'WNorm.h'
C        Parameters for when angle ~0 and slow development (fs2002)
         parameter (ACUT=1D-4 )
C         complex fold(nhk2),fentry(nhk2),predf(nhk2)
         save fmodel,amodel !,fold
C         save sfold,sfold2
         NCON=1
         CALL CNTRD (SYMM)
         P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
 
C     Angle conversion scaler
         PI = ASIN (1.D0)
         PI = PI * 2.D0
         PI2 = PI * 2.D0
         ACONV = 180.D0 / PI
 
         IF (PRINTF) WRITE (10, 998) NUSE
 
  998    FORMAT('***** DIVERGENCE ITERATION FOR ',I3,2X,' BEAMS *****'
     X      /3X,'H'
     X      ,2X,'K',6X,'Ent',8X,'Pos',6X,'Sum',5X,'Angle',4X,'F(H,K)')
 
C     Zero estimates for first cycle
C        IF (NCON .EQ. 1) THEN
C          DO   J=NREF+1,NPAD
C            FHK(J) = 0.
C            AHK(J) = 0.
C            FCALC(J) = 0.
C          END DO
C         ENDIF
C     save input values
         DO   J=1,NPAD
           AOLD(J) = AHK(J) * ACONV
           call equiv2(he,ke,ise,ih(j),k(j),ne,symm)
           centref(j)=.false.
           if(ise(1).eq.3)centref(j)=.true.
C           write(90,*)ih(j),k(j),centref(j), aold(j)
         END DO
         FMAX=FHK(1)
         DO J=2,NREF-1
             IF ((FHK(J) .GT. FMAX)) FMAX = FHK(J)
         ENDDO
C     setup in c the symmetry related values
         DO   J=1,M(1)*M(2)
           C(J) = (0., 0.)
         END DO
         II2 = M(1)
         II1 = M(1)
         modelmode=.false.
         IF(modelmode)then
C        ********* Normal Case ********
         else
C         write(10,*)'Non model'
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
C       Trap ?
           call anglefix(ang,p3flag)
           AHK(J) = ANG
           IF (centref(j) .AND. ABS (ANG) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
             IA = NINT (ANG / PI)
             IF (NINT (ANG / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
             AOLD(J) = AHK(J) * ACONV
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.D0
             SINAN = 0.D0
             F = 1.D0
             FHK(J) = 1.
             AHK(J) = PI2
             AOLD(J) = 360.
           ELSE IF (ABS (ANG) .LT. ACUT) THEN
             F = 0.D0
             COSAN = 0.D0
             SINAN = 0.D0
             AOLD(J)= 0.D0
           ELSE
             COSAN = COS (ANG) * F
             SINAN = SIN (ANG) * F
           END IF
      if(centref(j))sinan=0
C      fentry(j)=cmplx(cosan,sinan)
      do jj=1,ne
C     trap problems with p3 symmetry to give rectangular axes
         if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')then
            call p3exp(ihjj,ikjj,he(jj),ke(jj))
            ihjj=ihjj+n1c
            ikjj=ikjj+n2c
          else
            ihjj=he(jj)+n1c
            ikjj=ke(jj)+n2c
         endif
         ind=(ikjj-1)*n1+ihjj
         isjj=ise(jj)
         if(isjj.lt.0)then
            C(ind)=cmplx(cosan,-sinan)
        else if(isjj.lt.2)then
            C(ind)=cmplx(cosan,sinan)
         else if(isjj.eq.3)then
            C(ind)=cmplx(cosan,0.d0)
         else if(isjj.eq.6)then
            C(ind)=cmplx(0.d0,sinan)
         else if(isjj.lt.8)then
            C(ind)=cmplx(cosan,sinan)
         else if(isjj.lt.110)then
            awork=ang+he(1)*pi
            C(ind)=f*cmplx(cos(awork),sin(awork))

C     X or Y-glide
         else if(isjj.lt.210)then
            C(ind)=-cmplx(cosan,sinan)
         else if(isjj.eq.300)then
            C(ind)=-cmplx(cosan,-sinan)
            
C     p2mg case
         else if(isjj.eq.1000)then
            C(ind)=-cmplx(cosan,0.d0)
         else if(isjj.eq.2000)then
            C(ind)=cmplx(0.d0,-sinan)
         endif

           END DO
         END DO
C        ********* End of two cases *********
         endif
 
C     Perform the transformation
C     Negativity constraints via ftune(4)
         X1 = 0.
         XLAM = FTUNE(4) * (1 - EXP (0.5D0 - NCON * 0.5D0))
         X2 = XLAM
C     Model case -- flakey
C      if(modelmode)then
C        Setup, then use model
C        if(ncon.eq.1)then
C        CALL MODELSHARP0(N1,N2,M,C,modelog1)
C        else if (.not.modelog2)then
C         CALL MODELSHARP(N1,N2,M,C,modelog1)
C        else
C        CALL MODELSTRONG(N1,N2,M,C,modelog1)
C        endif
C         write(6,*)'After modelsharp'
C      else
         CALL SHPT2D (N1,N2,C,X1,X2)
C      endif
C         ComplexTwo = CMPLX (0.D0, 2.D0)
 
C     Outer loop for target reflections
         S1=0.0
         S1R=0.0
         S1I=0.0
         DO 1031 I=1,NPAD
           FRCALC(I) = 0.
           FICALC(I) = 0.
           ARCALC(I) = 0.
           AICALC(I) = 0.
           WI(I) = 1
           WR(I) = 1
C      if(ih(i).eq.0.and.k(i).eq.0)goto 1031
C       Average over equivalent reflections (does it matter?)
         call equiv2(he,ke,ise,ih(i),k(i),ne,symm)
         w1=0.
         w2=0.
         nnn=0
         do jt=1,ne

         if(ise(jt).eq.1.or.ise(jt).eq.3)then
           ihjj=he(jt)
           ikjj=ke(jt)
C     trap problems with p3 symmetry to give rectangular axes
         if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')
     $  call p3exp(ihjj,ikjj,he(jt),ke(jt))
          ih1=ihjj+n1c
          ik1=ikjj+n2c
          ih2=-ihjj+n1c
          ik2=-ikjj+n2c
         ind1=(ik1-1)*n1+ih1
         ind2=(ik2-1)*n1+ih2
         w1=w1+c(ind1)
         w2=w2+c(ind2)
         nnn=nnn+1
         endif

         enddo
         w1=w1/dble(nnn)
         w2=w2/dble(nnn)
C
C     Extract two terms from real and imag parts
           RES1 = (W1 + CONJG (W2)) * 0.5D0
           RES2 = (W1 - CONJG (W2)) * ComplexHalf
           if(centref(i))then
                res1 = dble(res1)
                res2 = dble(res2)
           endif
C    Correct for the effects of windows
        if(LENT2)RES2=RES2*ENTW(I)
        RES1=RES1*WNORM
C
C       Work around flakey g77 imag intrinsic
           ARSUM = res1a(1)
           BRSUM = res1a(2)
           AISUM = RES2a(1)
           BISUM = res2a(2)
 
           FSQ = RES1*CONJG(RES1) !ARSUM * ARSUM + BRSUM * BRSUM
           IF (FSQ .GT. 1D-16) THEN
             FRCALC(I) = SQRT (FSQ)
             ANG = ATAN2 (BRSUM, ARSUM)
             call anglefix2 ( ang, p3flag )
             ARCALC(I) = ANG
           END IF
           FSQ = RES2*CONJG(RES2) !AISUM * AISUM + BISUM * BISUM
           IF (FSQ .GT. 1D-16) THEN
             FICALC(I) = SQRT (FSQ)
             ANG = ATAN2 (BISUM, AISUM)
             call anglefix2 ( ang, p3flag )
             AICALC(I) = ANG
           END IF
C       Save values for pre-scaling
           WR(I) = COS (ARCALC(I) - AHK(I))
           WI(I) = COS (AICALC(I) - AHK(I))
           IF (AOLD(I) .LT. ACUT) THEN
             WI(I) = 1.
             WR(I) = 1.
           END IF
           if((I .LT. NREF).and.(AHK(I).gt.1e-2))then
                S1 =S1+ FHK(I)
                S1I=S1I+FICALC(I)
                S1R=S1R+FRCALC(I)
           endif
             ASUM = (1.-FWT)*FRCALC(I)+FWT*FICALC(I)
             IF (PRINTF) WRITE(10,4)IH(I),K(I),FRCALC(I),FICALC(I),
     X          ASUM,57.295779513D0 * AHK(I), FHK(I)
C     flag here to retain original values
 1031      CONTINUE
         sclr=S1/S1R
         scli=s1/S1I
         IF (PRINTF) WRITE (10,*)'Scale of Ent ',sclr,' Pos ',scli
         IF (PRINTF) WRITE (10, 100) NUSE
  100    FORMAT('***** END OF ITERATION FOR ',I3,2X,' BEAMS *****'/)
    4    FORMAT(2X,2I3,3F10.4,F8.2,F10.4)

C         write(10,*)'Scale Hack ',sclr,scli
C       For divergence, we can stop here
 1035      FORMAT('**** Estimated Reflections')
         TB2DC=1
         RETURN
       END
C

