      subroutine calcpoint(ih,k,l,fcalc,acalc,
     1  fgot,natom,zatom,itype,x,y,z,npad,symm)
C       Given x,y,z
C       Return in fcalc, acalc, values for 1 to npad beams
C       With a composite structure factor
        dimension xe(12),ye(12)
        dimension ih(*),k(*),l(*),fcalc(*),acalc(*)
        dimension fgot(*),zatom(*),itype(*)
        dimension x(*),y(*),z(*)
        character*4 symm
        complex amp
        include 'errref.h'
        include 'ffact.h'
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900)
         DIMENSION WINWTS(NHK2)
         COMMON /FOM5/WINWTS
C     Zero term
      f0=0
      ntot=0
      call settyp(itype,fgot,natom,zatom)
      do n=1,natom
         call asymm(x(n),y(n),ne,xe,ye,symm)
         f0=f0+ne
         ntot=ntot+ne
      enddo
      pi2=4.*asin(1.0)
      do j=1,npad
      u=ih(j)*pi2
      v=k(j)*pi2
      w=l(j)*pi2
      amp=0.0
      fcomp=0
      do n=1,natom
         call asymm(x(n),y(n),ne,xe,ye,symm)
         zp=w*z(n)
         do nn=1,ne
         p=u*xe(nn)+v*ye(nn)+zp
         amp=amp+cmplx(cos(p),sin(p))
         enddo
      enddo
C
C     Divide here by winwts -- applies windows mask
        amp=amp/winwts(j)
        fcalc(j)=sqrt(amp*conjg(amp))/f0
      if(fcalc(j).gt.1e-8)then
        acalc(j)=atan2(imag(amp),real(amp))
      else
        acalc(j)=0
      endif
      if(acalc(j).lt.1e-3)acalc(j)=acalc(j)+pi2
      enddo
      return
      end

