c 
c  Copyright (c) 1998 L. D. Marks
c 
c  This program is free software; you can redistribute it and/or modify
c  it under the terms of the GNU General Public License as published by
c  the Free Software Foundation; either version 2 of the License, or
c  (at your option) any later version.
c 
c  This program is distributed in the hope that it will be useful,
c  but WITHOUT ANY WARRANTY; without even the implied warranty of
c  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c  GNU General Public License for more details.
c 
c  You should have received a copy of the GNU General Public License
c  along with this program; if not, write to the Free Software
c  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c 
c
c cross selects parents and performs crossover in a given population

      subroutine crossN(tens,nchild,nparent,sdev)

        include 'Gpars.h'

      real bitsum1(npop)
      integer dmark,pmark1,pmark2
      real csim(npop),cs(npop)
C       real wheel(npop)
      logical trapocc,traprep,partlog(ngmax)
      save ismode, istens
      data ismode/0/,istens/9/
      integer*2 partest(ngmax)
C       data irun/0/
C       save irun
C       character*7 filen,file2
C       if(irun.lt.10)then
C               write(filen,901)'cross0',irun
C               write(file2,901)'parnt0',irun
C       else
C               write(filen,902)'cross',irun
C               write(file2,902)'parnt',irun
C       endif
C901    format(a,i1)
C902    format(a,i2)
C       open(unit=16,file=filen)
C       open(unit=17,file=file2)
C       irun=irun+1
c       Sharing      
c       Find max and min values
        fmax=-100
        fmin=100
        ismode=ismode+1
        if(ismode.gt.1)ismode=0
        istens=istens+3
        if(istens.gt.12)istens=6
        do j=1,nparent
                if(fompar(j).gt.fmax)fmax=fompar(j)
                if(fompar(j).lt.fmin)fmin=fompar(j)
C               write(17,913)fompar(j),(parent(jj,j),jj=1,npars)
C913            format(f10.5,'  ',50i1)
        enddo
c       Run through and find cross-similarity
c       Tension adjusted fitness, max at start, decreasing
C       wsum=0
        frange=(fmin-fmax)*float(nparent)
        frange=max(frange,1e-5)
C       TTens was 9, reduce?
        ttens=istens
C       fff=ttens*tens+1
C       write(6,*)'Cross At 1'
        do i=1,nparent
                ff=(fompar(i)-fmax)/frange
                ff=max(ff,1e-5)
C               wheel(i)=ff*(nparent+1-i)*ttens*tens+1
C               wheel(i)=wheel(i)/fff
C               wsum=wsum+wheel(i)
C               bitsum1(i)=wheel(i)
C               ww=(nparent+i-i)/float(nparent)
                bitsum1(i)=abs(ff*(nparent+i-1)*ttens*tens+1)
        enddo
C       do i=1,nparent
C               wheel(i)=wheel(i)/wsum
C       enddo
C       do i=2,nparent
C               wheel(i)=wheel(i-1)+wheel(i)
C       enddo
C       write(6,*)'Cross At 2'
        csum=0
        ctt=sqrt(float(nparent))
        s1=0
        s2=0
        do i=1,nparent
                csim(i)=0
        enddo
        do i=1,nparent-1
C               Copy target to partest...faster ?
                do jj=1,npars
                        partest(jj)=parent(jj,i)
                        if(partest(jj).eq.0)then
                                partlog(jj)=.false.
                        else
                                partlog(jj)=.true.
                        endif
                enddo
                do j=i+1,nparent
                        itemp=0
                        do jj=1,npars
C       Use a similarity of 1 if the same, 1/4 if both occupied
                        if(partest(jj).eq.parent(jj,j))then
                                itemp=itemp+4
                        else if(parent(jj,i).ne.0.and.partlog(jj))then
                                itemp=itemp+1
                        endif
                        enddo
                if(ismode.eq.1)then
                        csim(i)=csim(i)+itemp
                        csim(j)=csim(j)+itemp
                else
                        csim(i)=csim(i)+itemp*bitsum1(j)
                        csim(j)=csim(j)+itemp*bitsum1(i)
                endif
                enddo
        enddo
c       Save in csim(i) the shared fitness probability
        do i=1,nparent
                temp=csim(i)*0.25
                c4=temp/float(nparent)
                c4=c4*c4
                csim(i)=ctt*bitsum1(i)/c4
                if(i.eq.1)then
                        cscl1=csim(1)
C                       cscl2=c2
                endif
                csum=csum+csim(i)
C               Consistency terms
                s1=s1+temp
                s2=s2+temp*temp
        enddo
C
C       Mean of consistency
        s1=s1/float(nparent)
C       STD^2 of consistency
        sdev=(s2-nparent*s1*s1)/nparent
        if(sdev.gt.1e-5)then
                sdev=100*sqrt(sdev)/s1
        else
                sdev=1
        endif
C       write(6,*)'Cross At 3'
c       Renormalize
        do i=1,nparent
                csim(i)=csim(i)/csum
                cs(i)=csim(i)
        enddo
C       write(6,*)'Cross At 4'  
c start loop for reproduction
        idum=2
        imode=0
        sumcur=1
        mode=0
        do 200 m=1,nchild,2
        nreject=0
        mode=mode+1
        if(mode.gt.3)mode=1
c       We now have, the absolute probabilities
c       weighted by a shared distanace fitness term
c       Sort these up
        csim(1)=cs(1)/sumcur
        do i=2,nparent
                csim(i)=csim(i-1)+cs(i)/sumcur
        enddo
c        select first parent
c        create random number for parent selection
                r1=ranc1(idum)
                
        do i=1,nparent
                if(r1.le.csim(i))then
                        pmark1=i
                        goto 210
                endif
        enddo
        pmark1=nparent
210     continue

c        select second parent
        if(mode.eq.3)goto 300
cc *************** NEW version *************** EL 4_4_97
cc this is based on a sharing algorithm where the 
cc second parent is chosen based upon how similar 
cc it is to the first parent. Goldberg 1985.

C       Copy target to partest...faster ?
        do jj=1,npars
                partest(jj)=parent(jj,pmark1)
                if(partest(jj).eq.0)then
                        partlog(jj)=.false.
                else
                        partlog(jj)=.true.
                endif
        enddo
        bsum=0
        do ii=1,nparent
            bitsum1(ii)=0
C               Skip cases when probability is vanishing!
                if(cs(ii).lt.1e-6)goto 86
                if(ii.eq.pmark1)goto 86
                itemp=0
                do jj=1,npars
                        if(parent(jj,ii).eq.partest(jj))then
                                itemp=itemp+4
                        else if(parent(jj,ii).ne.0.and.partlog(jj))then
                                itemp=itemp+1
                        endif
                enddo
                temp=itemp*0.25
C       trap identicals
        if(temp+.1.gt.npars)temp=temp*0.5
c       Weight by shared fitness as well for mode=2
        if(mode.eq.2)then
                bitsum1(ii)=temp
        else
                bitsum1(ii)=temp*cs(ii)
        endif
        bsum=bsum+bitsum1(ii)
86      continue
        enddo
        
        do ii=1,nparent
                bitsum1(ii)=bitsum1(ii)/bsum
        enddo
        do ii=2,nparent
                bitsum1(ii)=bitsum1(ii)+bitsum1(ii-1)
        enddo

c        create random number for parent selection
 300     r1=ranc1(idum)
C       if(r1.lt.1e-5)goto 300
 
c        support chromosomes with high fitness
        if(mode.eq.3)then
        do i=1,nparent
                if(r1.le.csim(i))then
                        pmark2=i
                        goto 310
                endif
        enddo
        else
        do i=1,nparent
                if(r1.le.bitsum1(i))then
                        pmark2=i
                        goto 310
                endif
        enddo
        endif
        pmark2=nparent
310     continue
        
        if (pmark1 .eq. pmark2) goto 300
        if (abs(fompar(pmark1)-fompar(pmark2)).lt.1e-5)goto 300


c       select dividing point
c       create random number for dividing point
        itries=0
320             r1=ranc1(idum)
                dmark = 1 + aint(r1*(real(npars-1)))

c       write next generation
        do j=1,dmark
                child(j,m)  =parent(j,pmark1)
                child(j,m+1)=parent(j,pmark2)
        enddo
        do j=dmark+1,npars
                child(j,m)  =parent(j,pmark2)
                child(j,m+1)=parent(j,pmark1)
        enddo
C       trap occupancies
        if(trapocc(child,m,ngmax,npop))goto 9300
        if(trapocc(child,m+1,ngmax,npop))goto 9300
C       trap repeats
        if(traprep(child,m+1,ngmax,npop))goto 9300
        goto 9301
9300    nreject=nreject+1
        if(nreject.lt.10)goto 300
9301    continue
                
c     write next generation into file 'lpop'
C        write(16,88)pmark1,pmark2,fompar(pmark1),fompar(pmark2),
C    1  cs(pmark1),cs(pmark2),mode
C88      format(2i5,4f12.8,i4)

c end loop for reproduction
c       Reduce probability for parents
        cs(pmark1)=cs(pmark1)-1.0/float(nchild)
        if(cs(pmark1).lt.1e-6)cs(pmark1)=0
        cs(pmark2)=cs(pmark2)-1.0/float(nchild)
        if(cs(pmark2).lt.1e-6)cs(pmark2)=0
        sumcur=0
        do i=1,nparent
                sumcur=sumcur+cs(i)
        enddo

200   continue
C       close(unit=16)
      return
      end
      logical function trapocc(child,m,ngmax,npop)
      include 'Atoms.h'
      integer*2 child(ngmax,npop)
      dimension fhk(1500)
      dimension occ(natf),zocc(20)
      dimension liml(20),limn(20),numbn(100),igotn(20)
      common /fomgen/fhk,nref,natom,occ
      common /fomgen2/ntypes,zocc
      common /ffcom10/liml,limn,numbn,igotn,nlimn
      trapocc=.false.
      ito=0
      do jj=1,ntypes
                igotn(jj)=0
      enddo
      do jj=1,natom
C           decode the occupancy
            i=child(jj,m)
            if(i.ne.0)then
               ito=10
            if(nlimn.lt.0)igotn(i)=igotn(i)+numbn(jj)
            endif
      enddo
C     Trap no atoms
      if(ito.eq.0)then
        goto 999
      else
c       trap for too many
        if(nlimn.lt.0)then
                do jj=1,ntypes
                if(igotn(jj).gt.limn(jj))then
                        goto 999
                else if(igotn(jj).lt.liml(jj))then
                        goto 999
                endif
                enddo
        endif
      endif
      return
999   trapocc=.true.
      return
      end
        logical function traprep(child,m,ngmax,npop)
      include 'Atoms.h'
      integer*2 child(ngmax,npop)
      dimension fhk(1500)
      dimension occ(natf)
C      dimension liml(20),limn(20),numbn(100),igotn(20),zocc(20)
      common /fomgen/fhk,nref,natom,occ
C      common /fomgen2/ntypes,zocc
C      common /ffcom10/liml,limn,numbn,igotn,nlimn
      traprep=.false.
      if(m.lt.3)return
      m1=m-1
      do j=1,m-2
      do jj=1,natom
      if(child(jj,j).ne.child(jj,m1))goto 100
      enddo
C       we get here for a duplicated
        traprep=.true.
        return
100     continue
      do jj=1,natom
      if(child(jj,j).ne.child(jj,m))goto 200
      enddo
C       we get here for a duplicated
        traprep=.true.
        return
200     continue
        enddo
        return
        end


