        subroutine cleaner(x,y,symm,tolold)
        dimension xe(20),ye(20)
        character*4 symm
        logical dist2D,specx,specy
        if(specx(x,y,symm))return
        if(specy(x,y,symm))return       
C       Over-ride old tolerance
        tol=0.5
        call asymm2(x,y,ne,xe,ye,symm)
        if(ne.eq.1)return
C       do j=1,ne
C               xe(j)=xe(j)-nint(xe(j))
C               ye(j)=ye(j)-nint(ye(j))
C       enddo
        xx=xe(1)
        yy=ye(1)
        nav=1
        do k=2,ne
                dx=xe(1)-xe(k)
                dy=ye(1)-ye(k)
C               Trap atoms more than one unit cell away
C               Displace the effective atom xq,yq
                xq=xe(k)+nint(dx)
                yq=ye(k)+nint(dy)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                        if(dist2D(dx,dy,tol))then
C                       The atoms are too close
                        xx=xx+xq
                        yy=yy+yq
                        nav=nav+1
                endif
        enddo
        if(nav.gt.1)then
                x=xx/float(nav)
                y=yy/float(nav)
        endif
        return
        end

        subroutine cleanerd(x,y,symm,tolold)
        real*8 xe(20),ye(20),xx,xq,yq,x,y
        character*4 symm
        logical dist2D,specxd,specyd
        if(specxd(x,y,symm))return
        if(specyd(x,y,symm))return
C       Over-ride old tolerance
        tol=0.5
        call asymm2d(x,y,ne,xe,ye,symm)
        if(ne.eq.1)return
C       do j=1,ne
C               xe(j)=xe(j)-nint(xe(j))
C               ye(j)=ye(j)-nint(ye(j))
C       enddo
        xx=xe(1)
        yy=ye(1)
        nav=1
        do k=2,ne
                dx=xe(1)-xe(k)
                dy=ye(1)-ye(k)
C               Trap atoms more than one unit cell away
C               Displace the effective atom xq,yq
                xq=xe(k)+nint(dx)
                yq=ye(k)+nint(dy)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                if(dist2D(dx,dy,tol))then
C
C                       The atoms are too close
                        xx=xx+xq
                        yy=yy+yq
                        nav=nav+1
                endif
        enddo
        if(nav.gt.1)then
                x=xx/dble(nav)
                y=yy/dble(nav)
        endif
        return
        end
        
        
