C	WARNING: BONDING MAY BE WRONG !
C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine grid3Dg(fw,f,h,k,l,natom,nr2,x,y,z,
     1  obest,rbest,isymm,winwts,n1,n2,n3,rflag,ntyp,
     2  wts,fwt_on)
        include 'Gpars.h'
        include 'ffact2.h'
        include 'rfact.h'
        include 'Atoms.h'
        include 'Just_Pars.h'
        include 'errref.h'
      dimension x(*),y(*),z(*),winwts(*),wts(*)
      logical fwt_on
      dimension f(*),xmm(1500),fw(*)
      parameter (natf5=natf*5)
      integer itype(natf5),itypew(natf5)
      dimension fhk(1500),ind(200),work(natf5)
      dimension occ(natf*5),wt(1500),ohold(natf5)
      dimension xpre(natf5),ypre(natf5),zpre(natf5)
C      complex fbase(1500)
      integer h(*),k(*),l(*),isolt(natf5)
	real*4 nh(natf5)
      dimension obest(*)
      dimension xb(natf5),yb(natf5),zb(natf5)
	dimension xh(natf5),yh(natf5),zh(natf5)
	integer h2d(natf5),nhn(natf5)
C	dimension xht(natf),yht(natf),zht(natf)
C	save xht,yht,zht,nht
C	data nht/0/
        include 'hunting.h'
C        dimension xht(500),yht(500),zht(500)
C        common /hunter/xht,yht,zht,nht
C	dimension xsd(40,100),ysd(40,100),zsd(40,100),isd(40,100)
C	dimension ntsd(100)
C	common /hunter2/ xsd,ysd,zsd,isd,nsd,ntsd
C      include 'SeedDef.h'
      character*4 ssp,ssy,isymm
      character*1 quo
C     complex amp
      dimension zocc(20),xe(20),ye(20)
      integer vals(natf5),itcode(20)
      common /fomgen/fhk,fbase,nref,natm,occ
      common /fomgen2/ntypes,zocc
      logical rflag,dist2D,specx,specy,hdwref,dist3D,dist3Dr
      logical gotentry
      dimension ftrueh(nhk2h)
      common /sfcom40/ftrueh,gotentry
      include 'GenPass.h'
      logical bonding
      dimension bumpa(10,10),bonda(10,10)
      common /cmod01/bumpa,bonda
      common /cbnd01/bonding

C	For D.W. refinement
      logical robnod,rob_fit,dwref,robfm,nodd5
      common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      dimension dwbest(20),tempfin(20)
      Include 'Sfacts.h'
      character*4 sftemp
C     Start by sorting seeds
      call sortseed(xb,yb,zb,itypew,obest,nat,rbest,zatom)
C     Only use 30 seed max
      nsd = min(30,nsd)
C	Expand the search set with prior "good" values?
	naht=0
	symm=isymm
	ntypes=ntyp
	if(nsd.gt.0)then
C	Add seed atoms if not already present
	do js=1,nsd
		do j=1,ntsd(js)
		call asymm(xsd(j,js),ysd(j,js),ne,xe,ye,symm)
		do jj=1,natom
C			dz=zsd(j,js)-z(jj)
			do n=1,ne
				dx=xe(n)-x(jj)
				dy=ye(n)-y(jj)
				dx=dx-nint(dx)
				dy=dy-nint(dy)
C				if(dist3D(dx,dy,dz,1.0))goto 2101
                                if(dist2D(dx,dy,1.0))goto 2101
			enddo
		enddo
C	If we get here, the atom was not previously there
		naht=naht+1
		natom=natom+1
		x(natom)=xht(j)
		y(natom)=yht(j)
C		z(natom)=zht(j)
                z(natom)=0
2101		continue
		enddo
	enddo
	endif
        write(6,*)'Sites from seeds ',naht
C	For 2D, initialize counted then check for duplicates
C	if(n3.eq.1)then
C		do j=1,natom
C			h2d(j)=1
C		enddo
C		do j=1,natom-1
C		call asymm(x(j),y(j),ne,xe,ye,symm)
C		do jj=j+1,natom
C			dz=0
C			do n=1,ne
C				dx=xe(n)-x(jj)
C				dy=ye(n)-y(jj)
C				dx=dx-nint(dx)
C				dy=dy-nint(dy)
C				Add Double for hunting in 2D
C				if(dist3D(dx,dy,dz,1.0))then
C                                if(dist2D(dx,dy,1.0))then
C					h2d(j)=h2d(j)+1
C					h2d(jj)=h2d(jj)+1
C				endif
C			enddo
C		enddo
C		enddo
C	endif
	if(nht.gt.0)then
                njh=0
		do j=1,nht
		call asymm(xht(j),yht(j),ne,xe,ye,symm)
		do jj=1,natom
C			dz=zht(j)-z(jj)
                        dz=0
			do n=1,ne
				dx=xe(n)-x(jj)
				dy=ye(n)-y(jj)
				dx=dx-nint(dx)
				dy=dy-nint(dy)
C				Add Double for hunting in 2D
C				if(dist3D(dx,dy,dz,1.0).and.n3.eq.1)then
C					Do we already have it?
C					if(h2d(j).gt.1)goto 2100
C				No, so let it be addable
C					h2d(j)=h2d(j)+1
C				else if(dist3D(dx,dy,dz,1.0))then
                                if(dist3D(dx,dy,dz,1.0))then
					goto 2100
				endif
			enddo
		enddo
C	If we get here, the atom was not previously there
		naht=naht+1
		njh=njh+1
		natom=natom+1
		x(natom)=xht(j)
		y(natom)=yht(j)
C		z(natom)=zht(j)
                z(natom)=0
2100		continue
		enddo
	write(6,*)'Sites from hunting ',njh
	endif
	if(naht.gt.0)write(6,*)'Adding ',naht,' to sites'
	write(6,*)'Entering with ',nsd,' Seeds'
C	Trap sites to less than 40
	if(natom.gt.ngmax)natom=ngmax
	nht=0
      hdwref=dwref
      ssp=symm
	dwref=.false.
	ndw=0
	ipass=1
      rbest=1e9
      
      ntypes=ntyp
      natm=natom
      ssy=symm
C     Run through and eliminate 0,0,0 reflection
      f0=0.
      do j=1,nr2-1
C            fhk(j)=f(j)*wts(j)
C            if(symm.eq.'p3  ')fhk(j)=ftrueh(j)*wts(j)
            fhk(j)=ftrueh(j)*wts(j)
C            fbase(j)=0.0
C     Base f0
            f0=f0+fhk(j)*fhk(j)
            wt(j)=wts(j)/winwts(j)
      enddo
      nref=nr2-1
      f0=0.
      do j=1,nrref
      	f0=f0+rfhk(j)*rfhk(j)
      enddo

C     Cleanup atoms close to symmetry points
      do i=1,2
      do j=1,natom
      if(specx(x(j),y(j),symm))inod=1
      if(specy(x(j),y(j),symm))inod=1
      call cleaner(x(j),y(j),symm,1.0)
      enddo
      enddo
C	Save atomic positions
	do j=1,natom
		xh(j)=x(j)
		yh(j)=y(j)
C		zh(j)=z(j)
                zh(j)=0
		nh(j)=1
		nhn(j)=0
	enddo
      
C     Find out how which types (move up later)
      nlimn=10
      if(ntypes.gt.1)then
C         write(6,*)'Enter z*occ for each of',ntypes
C         read(5,*)(zocc(j),j=1,ntypes)
        do j=1,ntypes
                zocc(j)=zatom(j)
                limn(j)=9999
                liml(j)=0
        enddo
        write(6,300)'Limit numbers ? (Y/N) '
300	format(a,$)
301	format(a,i2,a,f6.3,a,$)
C        read(5,*)nlimn
        nlimn=1
        read(5,300)QUO
        if(QUO.eq.'Y'.or.QUO.eq.'y')then
                do j=1,ntypes
                write(6,301)'Type ',j,' z*occ ',zocc(j),' Min/Max ? '
                read(5,*)liml(j),limn(j)
                enddo
                nlimn=-1
        endif
      else
         zocc(1)=1
         ntypes=1
      endif
	do j=1,natom
		call asymm(x(j),y(j),ne,xr,yr,symm)
		numbn(j)=ne
	enddo
	
      nocc=ntypes+1
2000  call setup3Db(h,k,l,fw,nref,natom,x,y,z,symm,wt)
C     Genetic search
      do j=1,natom
         vals(j)=ntypes+1
         xr(j)=x(j)
         yr(j)=y(j)
C         zr(j)=z(j)
         zr(j)=0
      enddo
	npars=natom
C	Old
      nparent=10*nocc*natom
C	New
      nparent=100+10*(min(25,natom)+nocc+1)
      nparent=max(100,nparent)
      if(nparent.gt.npop)then
         write(10,*)'Warning: nparent too large'
         nparent=npop
      endif
      nchild=nparent
      nchild=2*(nchild/2)
      nparent=nchild
      if(nchild.gt.npop)then
         write(10,*)'Warning: nchild too large'
         nchild=npop
         nparent=npop
      endif
      ncycle=24
      if(nchild.lt.200)then
        nsol=nchild
      else
        nsol=200
      endif
      nelite=nparent/12
      nelite=max(nelite,1)
      prob=0.05
      nvar=natom
      icld=1
C
	if(nsd.gt.0.and.ipass.eq.1)then
C	reseed with prior peaks found, 1st pass only
	nparent=nchild
      do j=1,nvar
         nvals(j)=vals(j)
      enddo
	idum=-1
c     Decode the occupancies
      call settyp(itcode,zocc,ntypes,zatom)
	call ginitN(nchild)
	write(6,*)'Adding ',nsd,' Seeds'
	do j=1,nsd
		do j1=1,natom
			child(j1,j)=0
		enddo
		do j2=1,ntsd(j)
C	For each seed, find the corresponding closest atoms
C	Loop over atoms in seed
			rmin=1e9
			iok=0
                        jmin=1
C	Compare to all peaks currently there
			do jj=1,natom
				dx=x(jj)-xsd(j2,j)
				dy=y(jj)-ysd(j2,j)
C				dz=z(jj)-zsd(j2,j)
                                dz=0
				dx=dx-nint(dx)
				dy=dy-nint(dy)
				if(dist3Dr(dx,dy,dz,0.75,r))then
					if(r.lt.rmin)then
						iok=1
						rmin=r
						jmin=jj
					endif
				endif
			enddo
C	It was previously there
			if(iok.gt.0)then
			do j3=1,ntypes
				if(itcode(j3).eq.isd(j2,j))then
				child(jmin,j)=itcode(j3)
				endif
			enddo
			endif
		enddo
	enddo
C	If we have only one, do a one-point mutation repeat of others
	if(nsd.eq.1)then
		idum=-1
		do j=1,natom
			iic=child(j,1)
			do jc=1,nvals(1)-1
				if(jc.ne.iic)then
				icld=icld+1
C	Jump out if we have too many
				if(icld.gt.nelite)then
					icld=icld-1
					goto 9901
				endif
C				write(6,*)'Ug 2 ',icld
				do j2=1,natom
				child(j2,icld)=child(j2,1)
				enddo
				child(j,icld)=jc
				endif
			enddo
		enddo
9901		continue
		write(6,*)'Added ',icld,' mutations'
	endif
	endif			
	if(ipass.eq.1.and.nsd.eq.0)then
C	First time and no prior atoms - -ve to initialize
		initg=-1
	else if(nsd.gt.0.and.ipass.eq.1)then
C	First time and some atoms
		initg=2
	else
		initg=2
		if(conn.or.bonding)then
C	Otherwise, use what we have at the moment, corrected solutions
C		Copy solutions (which may have been corrected for occupancies
		do jL=1,nsol
			jjL=nchild-nsol+jL-10
			if(jjL.gt.nsol)then
C			write(6,*)jjL,nsol,' Ug1'
			do j2=1,natom
				child(j2,jjL)=solutions(j2,jL)
			enddo
			endif
		enddo
		endif
	endif
C	write(6,*)'Initialization code ',initg
C	Setup the bonding matrix if appropriate
	call 	bonddset(x,y,z,symm,natom)
	chifactor=1
        call geneticb(nvar,vals,nchild,nparent,ncycle,nelite,
     $  nsol,prob,fw,initg)

        fomold=1000
        do j=1,natm
                xpre(j)=0
                ypre(j)=0
                zpre(j)=0
                nh(j)=0
                nhn(j)=0
        enddo
C	Short refine on top 80
	if(.not.rflag)then
		do j=1,60
			ind(j)=j
		enddo
		goto 412
	endif
      imax=80
      j=0
      ll=0
      do jj=1,natom
      	isolt(jj)=0
      enddo
411    j=j+1
C       Bonding?
	if(j.gt.nsol)then
		imax=j-1
		goto 2002
	endif

        include 'unbond2.h'

C     trap bug with nothing there (why ?)
      ii=0
      iii=0
      do jj=1,natom
         ii=ii+solutions(jj,j)
         iii=iii+abs(solutions(jj,j)-isolt(jj))
      enddo
      if(ii.eq.0)then
		do jj=1,natom
			solutions(jj,j)=isolt(jj)
		enddo
		fomsol(j)=fomold
		goto 411
	endif
C	Trap for previous the same
      if(iii.eq.0)then
        fomsol(j)=fomold
      	goto 411
      endif
      	fomold=fomsol(j)
      do jj=1,natom
      	isolt(jj)=solutions(jj,j)
      enddo
      ll=ll+1
C     Copy over atoms
       nat=0
      do jj=1,natom
         i=solutions(jj,j)
         if(i.ne.0)then
            nat=nat+1
            occ(nat)=zocc(i)
            xr(nat)=x(jj)
            yr(nat)=y(jj)
C            zr(nat)=z(jj)
            zr(nat)=0
         endif
      enddo
        errg=fomsol(j)
        errg2=errg
	if(dwref)then
		do j=1,ndw
			tempf(j)=tempfin(j)
		enddo
	endif
          call settyp(itypew,occ,nat,zatom)
          if(rflag)then
              call gref3Dn(fhk,fbase,nref,nat,
     $        xr,yr,zr,symm,h,k,l,10,n1,n2,n3,errg2,itypew)
              fomsol(j)=errg2
          endif

        work(ll)=errg2/1000.
        ind(ll)=j
C	write(6,*)'Inter ',ll,' fom ',errg2
	if(10*(ll/10).eq.ll)write(6,*)'Prerefined ',ll
        if(ll.lt.imax)goto 411
C     Now do a sort
2002    call sortag(work,imax,ind)
C
C	End of pre-sort
C
412   if(ipass.eq.1)then
		num=40
		nrun=10
	else
		num=20
		nrun=15
	endif
      if(symm.eq.'p3  ')num=40
      if(rflag)write(6,40)' Refining top ',num,' .... slow !'
40      format(a,i3,a)
      j=0
      ll=0
      do jj=1,natom
      	isolt(jj)=0
      enddo
41    j=j+1
C     trap bug with nothing there (why ?)
      ii=0
      if(j.gt.imax)goto 2001
      jn=ind(j)
C     Trap jn=0 ??
      if((jn.le.0.).or.(jn.gt.200))goto 41
      iii=0
      do jj=1,natom
         ii=ii+solutions(jj,jn)
         iii=iii+abs(solutions(jj,jn)-isolt(jj))
      enddo
      if(ii.eq.0)goto 41
C	Trap for previous the same
      if(iii.eq.0)goto 41
      ll=ll+1
C     Copy over atoms
       nat=0
      do jj=1,natom
         i=solutions(jj,jn)
         isolt(jj)=i
         if(i.ne.0)then
            nat=nat+1
            occ(nat)=zocc(i)
            xr(nat)=x(jj)
            yr(nat)=y(jj)
C            zr(nat)=z(jj)
            zr(nat)=0
         endif
      enddo
        errg=fomsol(jn)
        errg2=errg
          call settyp(itypew,occ,nat,zatom)
          call gref3Dn(fhk,fbase,nref,nat,
     $        xr,yr,zr,symm,h,k,l,nrun,n1,n2,n3,errg2,itypew)
          fomsol(jn)=errg2

C	Average
	if((ipass.eq.1).and.(j.le.100))then
		nt=0
		do jj=1,natom
		i=solutions(jj,jn)
		if(i.ne.0)then
			nt=nt+1
			dx=x(jj)-xr(nt)
			idx=nint(dx)
			if(idx.ne.0)then
				dx=dx-idx
				xr(nt)=xr(nt)-idx
			endif
			dy=y(jj)-yr(nt)
			idy=nint(dy)
			if(idy.ne.0)then
				dy=dy-idy
				yr(nt)=yr(nt)-idy
			endif
C			dz=z(jj)-zr(nt)
                        dz=0
C	Trap the atom moving more than 0.75 Angers away
		if(dist3D(dx,dy,dz,0.5))then
                        wuse=1./(errg2*errg2)
			xpre(jj)=xpre(jj)+xr(nt)*wuse
			ypre(jj)=ypre(jj)+yr(nt)*wuse
			zpre(jj)=zpre(jj)+zr(nt)*wuse
			nh(jj)=nh(jj)+wuse
			nhn(jj)=nhn(jj)+1
		endif
		endif
		enddo
	endif
	continue
        write(6,30)' Solution ',ll,' G-of-Fit ',fomsol(jn)
       if(ipass.gt.1)write(13,30)'REM Test ',ll,' G-of-Fit ',fomsol(jn)
       write(10,30)'REM Test ',ll,' G-of-Fit ',fomsol(jn)
       if(errg2.lt.rbest)then
          rbest=errg2
          do jj=1,nat
             xb(jj)=xr(jj)
             yb(jj)=yr(jj)
             zb(jj)=zr(jj)
             obest(jj)=occ(jj)
          enddo
          nbest=nat
       endif
	if(ipass.gt.1)then 
	if(ipass.gt.1.and.nsd.le.60.and.errg2.lt.rbest*3)nsd=nsd+1
C	if(nsd.le.30)write(6,*)'Storing ',nsd,nat
	endif
      do jj=1,nat
            sftemp=sfacts(itypew(jj))
            isf2=2
            if(sftemp(2:2).eq.' ')isf2=1
            if(jj.gt.9)then
            write(10,11)jj,xr(jj),yr(jj),zr(jj),occ(jj),0.05
            if(ipass.gt.1)write(13,111)sftemp(1:isf2),jj,xr(jj),yr(jj),
     1      zr(jj),occ(jj),0.05
            else
            write(10,10)jj,xr(jj),yr(jj),zr(jj),occ(jj),0.05
            if(ipass.gt.1)write(13,101)sftemp(1:isf2),jj,xr(jj),yr(jj),
     1      zr(jj),occ(jj),0.05
            endif
		if(ipass.gt.1.and.nsd.le.60.and.errg2.lt.rbest*3)then
			xsd(jj,nsd)=xr(jj)
			ysd(jj,nsd)=yr(jj)
			zsd(jj,nsd)=zr(jj)
			isd(jj,nsd)=itypew(jj)
                        fomseed(nsd)=errg2
                        ntsd(nsd)=nat
		endif
      enddo
30      format(a,i3,a,2f8.4,4f12.7)
      if(ll.lt.num)goto 41
            
10      format('Q',i1,'  1 ',4f10.6,2x,2f8.3)
11      format('Q',i2,' 1 ',4f10.6,2x,2f8.3)
101     format(a,i1,'  1 ',4f10.6,2x,2f8.3)
111     format(a,i2,' 1 ',4f10.6,2x,2f8.3)
C	Now replace the peaks and rerun
2001	if(ipass.eq.1)then
		ipass=2
		do j=1,natm
C			Correct the weight
                        xh(j)=x(j)
                        yh(j)=y(j)
C                        zh(j)=z(j)
                        zh(j)=0
			if(nhn(j).gt.1)then
                                xh(j)=(xpre(j)/nh(j)+xh(j))*0.5d0
                                yh(j)=(ypre(j)/nh(j)+yh(j))*0.5d0
C                                zh(j)=(3*zpre(j)/nh(j)+zh(j))*0.25d0
			endif
			x(j)=xh(j)
			y(j)=yh(j)
C			z(j)=zh(j)
                        z(j)=0
C	Update the list of plausible atoms
			if(nh(j).gt.1.0001)then
				nht=nht+1
				xht(nht)=x(j)
				yht(nht)=y(j)
				zht(nht)=z(j)
			endif
		enddo
C     Cleanup atoms close to symmetry points
	if(nht.gt.0)then
      do i=1,2
      do j=1,nht
      if(specx(xht(j),yht(j),symm))inod=1
      if(specy(xht(j),yht(j),symm))inod=1
      call cleaner(xht(j),yht(j),symm,1.0)
      enddo
      enddo
	write(6,*)'Holding ',nht,' sites for later'
	endif
      do i=1,2
      do j=1,natm
      if(specx(x(j),y(j),symm))inod=1
      if(specy(x(j),y(j),symm))inod=1
      call cleaner(x(j),y(j),symm,1.0)
      enddo
      enddo
	goto 2000
	endif
C     End by sorting seeds
      call sortseed(xb,yb,zb,itypew,obest,nbest,rbest,zatom)
      do j=1,nbest
         x(j)=xb(j)
         y(j)=yb(j)
C         z(j)=zb(j)
         z(j)=0
      enddo
      natom=nbest
	nsd=min(20,nsd)
C	Purge the hunt list
	call phunt(xht,yht,zht,nht,1.0,symm)
C	Reset D.W.refinement
	dwref=hdwref	
        return
        end
