        subroutine readdata(x,y,z,fgot,itype,sfacts,zatom,natorm,IM)
        character*4 sfacts(*)
        character*80 line
        character*200 fname
        character*1 quo
        dimension x(*),y(*),z(*),fgot(*),zatom(*),itype(*)
        include 'Xray.h'
C       Names to skip
        parameter (nskip=8)
        character*4 skip(nskip)
        data skip/'TITL','REM ','LATT','SYMM','ZERR','SFAC','UNIT'
     1 ,'CELL'/
        parameter (nok=15)
        character*1 aok(nok)
        data aok/'0','1','2','3','4','5','6','7','8','9','+','-',
     1  '>','<',' '/
        save aok,skip
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
C       New stuff for structure factor recalculation
        dimension ih(20),k(20),L(20),F(20)
        logical FGET98
        include 'cellcon.h'
        include 'rfact.h'
        include 'ffact.h'
       iin=im
       if(im.lt.0)then
        quo='P'
       else if(im.gt.0)then
        quo='S'
        iin=im
       else
        quo='I'
       endif
      if(quo.eq.'S'.or.quo.eq.'s')then
       open(unit=2,file='search.lst')
C      Run down, reading 'R' from file
       natorm=0
7310   read(2,7102,err=999,end=999)quo
       if(quo.eq.'R')natorm=natorm+1
       if(natorm.lt.iin)goto 7310
C      O.K., we have skipped the appropriate number, so...
       natorm=0
       do j=1,50
         fgot(j)=0
       enddo
       do j=1,50
         read(2,7102)line
         call cleanline(line)
         if(line(1:1).eq.'Q')then
           natorm=natorm+1
           read(line(6:78),*)x(natorm),y(natorm),z(natorm),fgot(natorm)
         else
           goto 7311
         endif
       enddo      
7311   continue
      else if(quo.eq.'p'.or.quo.eq.'P')then
         open(unit=2,file='peaks.new')
         natorm=0
         do j=1,99
           read(2,7300,err=7301,end=7301)x(j),y(j),z(j),fgot(j)
           natorm=natorm+1
         enddo
7301     continue
        else if(quo.eq.'I'.or.quo.eq.'i')then
C       How many types do we have ?
        nt=0
      do j=1,20
         if(zatom(j).gt.-0.1)then
         nt=nt+1
         endif
      enddo
         read(5,7102)fname
C        Find termination by END
         do j=197,1,-1
            if(fname(j:j+3).eq.' END')then
              jn=j-1
              if(jn.lt.1)goto 899
              open(unit=2,file=fname(1:jn))
              goto 800
            endif
        enddo
C       If we get here, no name so try peaks.ins
        write(6,*)'Going to default'
        open(unit=2,file='peaks.ins')
800     continue
C       write(30,*)fname(1:jn)
C       Read lines and check against known
        natormn=0
        do j=1,999
C               write(30,*)'Ln ',j
                read(2,79,end=400,iostat=ii)line
C               Trap gfortran issues
                if((ii .ne. 7).and.(ii.ne.0))goto 400
C               Remove junk from the line
                call cleanline(line)
C               write(30,79)line
                do jj=1,nskip
                        if(line(1:4).eq.skip(jj))goto 100
                enddo
C       New, understand temperature factors
C           write(22,79)line
           IF (LINE(1:4) .EQ. 'TFAC') THEN
              write(*,*)'Found new Temperature terms'
C     Read in the temperature factors for each type of atom
              NI = 5
              NT = 0
  110         NT = NT + 1
              IF (FGET98 (LINE,NI,80,TEMPF(NT))) GO TO 120
              GO TO 110
  120         NT = NT - 1
C     Trigger a recalculation of the S.F's
              gotrfacts=.false.
              write(6,*)'Recalculating S.F.'
              call GEN3DR(f,IH,K,L,NREF,xray)
              gotrfacts=.true.
              GOTO 100
           ELSE IF(LINE(1:4) .eq. 'DWRE') THEN
              dwref=.true.
              goto 100
           ENDIF
C       How many characters in the type ?
                num=2
C       See if it any of the known characters
                do n=1,nok
                        if(line(2:2).eq.aok(n))then
                                num=1
                                goto 200
                        endif
                enddo
200             continue
C       If it is either a blank, or 0-9 we probably have an atom
                do n=1,nok
                        if(line(3:3).eq.aok(n))goto 300
                enddo
C       Not recognized as viable
C               write(20,*)'Not viable ',line(1:30)
                goto 100
C               Is it a known atom ?
300             continue
C       Recognize charges for arun
                if(line(3:3).eq.'>'.or.line(3:3).eq.'<')num=4
C               write(20,*)'Probable atom ',line(1:30)
C       Recognize +/- charges
                if(line(3:3).eq.'+')then
                       num=3
                else if(line(3:3).eq.'-')then
                       num=3
                else if(line(4:4).eq.'+')then
                       num=4
                else if(line(4:4).eq.'-')then
                       num=4
                else if(line(2:2).eq.'+')then
                       num=2
                else if(line(2:2).eq.'-')then
                       num=2
                endif
C
                do n=1,nt
                        if(sfacts(n)(1:num).eq.line(1:num))then
C       It is type nt
                        read(line(5:80),*,IOSTAT=ios)i,xx,yy,zz
C                       write(20,*)'Got ',xx,yy,zz
C                       write(*,*)'Got ',xx,yy,zz
                        if(ios.ne.0)then
                                goto 100
                        endif
                        natormn=natormn+1
                        x(natormn)=xx
                        y(natormn)=yy
                        z(natormn)=zz
                        fgot(natormn)=zatom(n)
                        itype(natormn)=n
                        goto 100
                        endif
                enddo
100     continue
        enddo
        else
C       Give up and finish
        return
      endif
400     close(unit=2)
      if(natormn.gt.0)then
        natorm=natormn
        write(10,*)' Found ',natorm,' atoms in readdata'
      else
        write(10,*)' No viable atoms found, aborting'
      endif
        return
999     write(10,*)'Error reading positions'
        return
899     write(10,*)'No file name !'
        return
7300  format(6x,4f10.6,2x,2f8.3)
7102    format(a)
79    format(a,' ? _',$)
        end
