       Subroutine POT3D(P,IH,KB,LB,NREF,D,L,
     $ VSUMZ,CT,NTYPE,F0,xray)
C     ROUTINE TO GENERATE POTENTIAL TERMS
C
        include 'controls.h'
        include 'NewStuff.h'
       DIMENSION P(*)
C       INTEGER ATOM1,ATOM2,ATOM3
       DIMENSION L(9),D(3),X(5),Y(5)
       real*8 D11,D12,D22,XI,XJ,XJ2,XIJ,FIJN,CT2,DTEMP,XT
       integer IH(*),KB(*),LB(*)
       logical xray
      character*4 csymb
	common /DBterm/btemp
C	Pass some stuff to rods calculation
	real*8 frzero
      Common /rodpass0/frzero,vsumzz,rodp0
      character*1 ctmp
      logical OK
      dimension nwork(20),zwork(20)
      dimension ave1(nhk2h),ave2(nhk2h)
C
	F0=0.0
       D11=0.25 /(D(1)*D(1))
       D22=0.25 /(D(2)*D(2))
       CT2=CT
       D12=0.5 /(D(1)*D(2))
       D33=0.25/(D(3)*D(3))
C       write(10,*)'Ntype ',ntype
C     LOOP OVER TYPES OF ATOMS
       DO 320 N=1,NTYPE
C     READ PARAMETERS FOR EACH TYPE OF ATOM
      temp=abs(tempf(n))
      csymb=sfacts(n)
      num=ncont(n)
C     dumc=csymb
C     atom2=ichar('    ')
C     atom3=atom2
      frac=aocc(n)
      itemp=0
      ixray=1
      zsumn=0
      NF=4
C	Do we have an integer, i.e. superimpose two atoms ?
	ifirst=-1

	do j=1,9
		write(ctmp,1000)j
1000		format(i1)
		if(csymb(1:1).eq.ctmp)ifirst=j
	enddo
C	write(6,*)'Testing ',csymb(1:2),' ',ifirst
       	if(ifirst.gt.0)then
C	   Yes case, find second value
	   isecnd=-1
	   do j=1,9
		write(ctmp,1000)j
		if(csymb(2:2).eq.ctmp)isecnd=j
	   enddo
	   if(isecnd.lt.1)then
		write(6,*)'ERROR: Invalid Type ',csymb(1:2)
		write(10,*)'ERROR: Invalid Type ',csymb(1:2)
		call exit(1)
	   endif
	   do J=1,nref
		ffact(j,n)=ffact(j,ifirst)+ffact(j,isecnd)
	   enddo
	   zatom(n)=zatom(ifirst)+zatom(isecnd)
	   zsumr(n)=zsumr(ifirst)+zsumr(isecnd)
	   write(10,361)sfacts(ifirst),sfacts(isecnd)
 361   FORMAT(/4X,' It contains overlapping atoms ',A,' & ',A/)
           goto 320
        endif
C     New version
      call scattf(cxray,x,y,zizz,csymb,charge)
      call nsfac(x,y,cxray,csymb,ok,zizz)
      NF=5
      if(.not.ok)then
        call scattf(cxray,x,y,zizz,csymb,charge)
        NF=4
      endif
C
C     FRACTIONAL OCCUPANCY ?
 10    IF(FRAC.LE.0.0 )GO TO 30
       DO 20 M=1,NF
 20    X(M)=FRAC*X(M)
       ZIZZ=ZIZZ*FRAC
       CXRAY=CXRAY*FRAC
C	write(10,*)'Dump x,y ',x,y,zizz,xray,d,btemp
C
C       X-RAY DATA
C     OUTPUT OF PARAMETERS
 30    WRITE(10,360)NUM,csymb,ZIZZ,FRAC,TEMP
C
C
 50    IP=0
c
       GGMAX=0.0
       DO 80 J=1,nref
       XJ=KB(J)
       XI=IH(J)
       XL=LB(J)
       XJ2=XJ*XJ*D22+XL*XL*D33
       XIJ=XJ*CT2*D12
       XSQQ=-(XJ2+XIJ*XI+XI*XI*D11)
       FIJN=0.0 
       if(-XSQQ .gt. GGMAX)GGMAX=-XSQQ
c
c     include temperature factor
      dtemp=xsqq*dble(temp)
      if(dtemp.lt.-15. )goto 70
       DO 60 M=1,NF
       XT=dble(Y(M))*XSQQ
       if(xt.gt.-40. )FIJN=FIJN+dble(X(M))*EXP(XT)
 60    CONTINUE
C
	if(xray)then
	 FIJN=(FIJN+dble(CXRAY))
	else
C     MOTT FORMULA 
         IF(XSQQ.lT.-1E-10)then
		FIJN=(FIJN+dble(CXRAY-ZIZZ))*0.0239340/XSQQ
	   else
		FIJN=0.023934D00*(X(1)*Y(1)+X(2)*Y(2)+
     1 	X(3)*Y(3)+X(4)*Y(4))
           if(NF.eq.5)FIJN=FIJN+0.023934D00*X(5)*Y(5)
	   endif
        endif

       fijn=fijn*exp(dtemp)
c     trap here for no negative terms
      if(fijn.lt.0.0d0)fijn=0.0d0
70    P(J)=P(J)+FIJN*FIJN*NUM
	ffact(j,N)=FIJN
	zsumn=zsumn+FIJN
C	write(18,888)ih(j),kb(j),lb(j),fijn,xsqq,xt
C888	format(3i4,5f12.5)
 80    CONTINUE
C      Ggmax is the max S**2, convert to g**2
       ggmax=ggmax*4.0D0
C
C    ZERO TERM FOR X-RAY CASE
C
151    if(xray)then
       	fijn=ZIZZ
       	vsumz=VSUMZ+float(num)*fijn
        f0=f0+float(num)*fijn*fijn
        FZERO=zizz
       else
       	fijn=0.023934D00*(X(1)*Y(1)+X(2)*Y(2)+
     1 	X(3)*Y(3)+X(4)*Y(4))
        if(NF.eq.5)FIJN=FIJN+0.023934D00*X(5)*Y(5)
       	vsumz=VSUMZ+fijn*num
        FZERO=fijn
        f0=f0+float(num)*fijn*fijn
        zsumn=zsumn+fijn
       endif
 130	btemp=temp
C
C     Save zero term
      zatom(n)=fzero
      zsumr(n)=zsumn
C	Patch to change zatom for charges?
	if(abs(charge).gt.1e-3)zatom(n)=zatom(n)+charge
c
 300   CONTINUE
C
 320   CONTINUE
c
C      Output ggmax, for convenience
       write(10,*)'GGMAX is ',ggmax,' Resolution ',1./sqrt(ggmax)
C      Experimental normalization
C      In principle this is better, but it is only about a 5% effect
C      Therefore let's ignore it
	do n=1,ntype
		zwork(n)=zatom(n)
		nwork(n)=ncont(n)
C		write(17,*)n,nwork(n),zwork(n)
	enddo
C	Take the sqrt for normalization
       DO 301 K=1,nref
        P(k)=sqrt(P(k))
301    continue
C       Experimental
        call StatFnorm(ave1,ave2,nref,ntype)
C       Alternative mode for normalization
C       Divide by an average, the opposite extreme of <F^2>
C        if(altP)then
                zall=zatom(1)*ncont(1)
                DO N=2,ntype
                        zall=zall+zatom(N)*ncont(N)
                enddo
                do K=1,nref
                        FIJN=FFACT(K,1)*ncont(1)
                        DO N=2,ntype
                                FIJN=FIJN+FFACT(K,N)*NCONT(N)
                        enddo
                        PK=FIJN/zall
                        write(55,55)ih(k),kb(k),P(k),PK,ave1(k),ave2(k)
55      format(2i4,4E14.6)
                enddo
C        endif
                                
c       Correct F0 to approximate number of atoms
        F0=vsumz*vsumz/f0
c	If NTYPE=1 and NUM=1 we have <F**2>=1 normalization in use
c	Trap this by setting F0=-1
	if(ntype.eq.1.and.num.eq.1)F0=-1.
c	output z*occ and relative integrated values
	zsmm=-99
	zatm=-99
	do j=1,ntype
		if(zatom(j).gt.zatm)zatm=zatom(j)
		if(zsumr(j).gt.zsmm)zsmm=zsumr(j)
	enddo
	write(10,*)
	write(10,*)'Relative Weights'
500	format(' Type ',i2,' Z*Occ ',f8.4,' Zsum ',f8.4)
	do j=1,ntype
	zatom(j)=zatom(j)/zatm
	zsumr(j)=zsumr(j)/zsmm
	write(10,500)j,zatom(j),zsumr(j)
	enddo
C       Store vsumz for rods
        vsumzz=vsumz
       RETURN
C
 360   FORMAT(/4X,' It contains ',I4,' ',A,' atoms, Z=',F8.4
     1/4x,' Occupancy ,',F6.3,' with Temperature Factor (B=8*pi*pi*U)'
     2 ,F8.3/)
 380   FORMAT(9F8.5)
 390   FORMAT(1H ,9F13.4)
 400   FORMAT(10F8.3)
 410   FORMAT(1H ,3F10.6)
 420   FORMAT(3F10.6)
       END

        subroutine StatFnorm(ave1,ave2,nref,ntype)
C       Experimental testing for normalization
        include 'controls.h'
        include 'NewStuff.h'
        dimension ave1(*),ave2(*)
	complex sum1(nhk2h),sum2(nhk2h),work
C
C       Initialize random number
        write(55,*)ntype,(ncont(i),i=1,ntype)
        write(55,*)nref
        call srand(0)
	ntot=100000
        pi2=2.*acos(-1.)
        do j=1,nref
                ave1(j)=0
                ave2(j)=0
        enddo
        npt=0
        do jj=1,10
	do j=1,ntot
                npt=npt+1
                do k=1,nref
                        sum1(k)=0
                        sum2(k)=0
                enddo
C       Loop over types
		do i1=1,Ntype
                  work=0
C       Loop for number of atoms of each type
                  do i2=1,ncont(i1)
                        a= pi2*rand(0)
C                       work=work+cmplx(cos(a),sin(a))
                        work=work+cos(a)
		  enddo
C       Loop over reflections
                   do k=1,nref
                        sum1(k)=sum1(k)+work*ffact(k,i1)
                        sum2(k)=sum2(k)+work*zatom(i1)
                   enddo
                enddo
C
C       Increment averages
                do k=1,nref
		        t1=sum1(k)*conjg(sum1(k))
                        t2=sum2(k)*conjg(sum2(k))
                        ave1(k)=ave1(k)+t1*t2/(t2*t2+1d-10)
                        t1=sqrt(t1)
                        t2=sqrt(t2)
                        ave2(k)=ave2(k)+t1*t2/(t2*t2+1d-10)
                enddo
	enddo
        enddo
C       Renormalize
        do k=1,nref
                ave1(k)=sqrt(ave1(k)/npt)
                ave2(k)=ave2(k)/npt
        enddo
	end
