C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE SHPT2D (N1, N2, M, C, IOPT, X1, X2 )
         COMPLEX C(*)
         INTEGER M(3), N1, N2, IOPT
         DOUBLEPRECISION XMEAN, XR, XI
         DOUBLEPRECISION XT,BCUT, XFLIP
         include 'NewStuff.h'
         LOGICAL  UFLIP
C     Positivity constraint as well
C     Do a FFT
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip.gt.1e-4)uflip=.true.
         XFLIP=FLIP/DBLE(N1*N2)
C
        INCLUDE 'EntScales.h'
C
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XT = dble(C(JK))
             IF (NF .LT. 0) XT=-XT
             IF (XT .LT. BCUT ) THEN
               XR = 0.D0
C       Reinstall positivity over-relaxation
C               XI = 0.
C               if(.not.LENTR)XI = -XT*X2
                XI = -XT*X2
             ELSE
               XR = XT * LOG (XT/XMEAN)
               XI = XT
               if(LENTR)
     X            XI= - XT * LOG(XT*ENTMUL)*ENTSCL
             END IF
             IF(UFLIP .AND. (XT .LT. XFLIP))XI=-XT
             IF(NF .LT. 0)then
                XR = - XR
                XI = - XI
             ENDIF 
             C(JK) = CMPLX (XR, XI)
           END DO
         END DO
 
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
 
