C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION TACC (IH, K, NREF, SYMM, NHK, C, M, TOL, I1, I2, S1, S2
     X    , IOPT )
 
         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         REAL*8 REL1,REL2
         PARAMETER (REL1 = 0.25D0, REL2 = 1.D0/(1.D0+REL1))
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
C         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
C     generate an approximate mask iteratively in wcom
         DIMENSION IH(NHK2), K(NHK2), FCALC(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*), CZERO
         PARAMETER (CZERO = (0.,0.) )
         CHARACTER*4 SYMM
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
C         REAL RR1, RR2, RR3
         DOUBLE PRECISION DD2, shift,XS,YS,FC,SUM1,SUM2,SCALE,PI
         LOGICAL P3FLAG
C        Window Normalization
         Include 'WNorm.h' 
C     setup fft tables
         CALL PBUF2 (M)
 
C     Make sure that iopt=13 (slow development) uses iopt=12
C     window
         IUSE = IOPT
 
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
C     Put the peak a little off-center
         XS  = Asin(1.D0)/dble(n1)
         YS  = Asin(1.D0)/dble(n2)
         ROLD = 1D6
 
C     Find the "largest" weight, not on zero beam
         WMAX = (-1.)
         DO   J=1,NREF
           IF (IH(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             IF (WTS(J) .GT. WMAX) THEN
               WMAX = WTS(J)
             END IF
           ELSE
             WTS(J) = 1.
           END IF
         END DO
         PI = ASIN (1.D0) * 2.D0
         RR1 = FLOAT (NREF - 1)
         TOL = TOL * 0.1D0
         DD2 = TOL * 0.001D0
 
         DO   NITER=1,50
C     setup in fo and ag the symmetry related values
C     zero beams
           DO   J=1,N1*N2
             C(J) = (0., 0.)
           END DO
 
C     setup in fo and ag the symmetry related values

           P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
           DO   J=1,NREF
             IHH = IH(J)
             IKK = K(J)
             CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
             F = WTS(J)
 
C     Information about symmetry coding of phases
             DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
               IF (P3FLAG) THEN
                 CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
C             ihjj=2*he(je)+n1c
C             ikjj=2*ke(je)+he(je)+n2c
                 IHJJ = IHJJ + N1C
                 IKJJ = IKJJ + N2C
               ELSE
                 IHJJ = HE(JJ) + N1C
                 IKJJ = KE(JJ) + N2C
               END IF
               IND = (IKJJ - 1) * N1 + IHJJ
               IF (ISE(JJ) .LT. 0) THEN
                 C(IND) = F
               ELSE IF (ISE(JJ) .EQ. 3) THEN
                 C(IND) = F
               ELSE IF (ISE(JJ) .EQ. 6) THEN
                 C(IND) = CZERO
               ELSE IF (ISE(JJ) .LT. 8) THEN
                 C(IND) = F
               ELSE IF (ISE(JJ) .LT. 110) THEN
                 AWORK = HE(1) * PI
                 C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
 
C     X or Y-glide
               ELSE IF (ISE(JJ) .LT. 210) THEN
                 C(IND) = -F
               ELSE IF (ISE(JJ) .EQ. 300) THEN
                 C(IND) = -F
 
C     p2mg case
               ELSE IF (ISE(JJ) .EQ. 1000) THEN
                 C(IND) = -F
               ELSE IF (ISE(JJ) .EQ. 2000) THEN
                 C(IND) = CZERO
               END IF
c               Shift term
                shift=dble(ihjj-n1c)*xs+dble(ikjj-n2c)*ys
                C(IND) = C(IND)*cmplx(cos(shift),sin(shift))
             END DO
 
           END DO
 
C     Perform the transformation
           CALL ESHP2D (N1,N2,M,C)
           POSRSCL = 1 
C     Outer loop for target reflection
           SUM1 = 0.
           SUM2 = 0.
           SUM3 = 0.
           SCAT = 0.
           SBIG = (-1.)
           EBIG = (-1.)
           i0=nref
           DO   I=1,NREF
             IF (IH(I) .EQ. 0 .AND. K(I) .EQ. 0) I0 = I
             CALL EQUIV2 (HE,KE,ISE,IH(I),K(I),NE,SYMM)
             NAV = 0
             FC = 0.
             SC1 = 0.
             DO   JE=1,NE
C     Average over equivalents
               IF (ISE(JE) .EQ. 1 .OR. ISE(JE) .EQ. 3 .OR.
     1          ISE(JE) .EQ. -1 ) THEN
                 NAV = NAV + 1
C           trap problems with p3 symmetry to give rectangular axes
                 IF (P3FLAG) THEN
                   CALL P3EXP (IHJJ,IKJJ,HE(JE),KE(JE))
                   IHJJ = IHJJ + N1C
                   IKJJ = IKJJ + N2C
                 ELSE
                   IHJJ = HE(JE) + N1C
                   IKJJ = KE(JE) + N2C
                 END IF
                 IND = (IKJJ - 1) * N1 + IHJJ
C             Inverse shift
              shift=dble(ihjj-n1c)*xs+dble(ikjj-n2c)*ys
              ftemp=c(ind)*cmplx(cos(shift),-sin(shift))
C                 FTEMP = C(IND)
                 FC = FC + FTEMP
                 SC1 = SC1 + FTEMP * FTEMP
               END IF
             END DO
C     Average
             FC = FC / FLOAT (NAV)
             FRMS = SQRT (SC1 / FLOAT (NAV))
C     Mean Squared Scatter
             SC1 = SC1 / FLOAT (NAV) - FC * FC
C     Add fractional scatter
             SC1 = SC1 / (FC * FC)
             SCAT = SCAT + SC1
C     Largest absolute scatter
             IF (SC1 .GT. SBIG) THEN
               SBIG = SC1
             END IF
C     Test
C             FC = (FRMS + FC) * 0.5D0
             FCALC(I) = FC
             SUM1 = SUM1 + NE * FC * FC
             SUM2 = SUM2 + NE * FC * WTS(I)
             SUM3 = SUM3 + WTS(I) * WTS(I) * NE
 
           END DO
 
C     Relative scaling of fcalc and input
           SCALE = SUM2 / SUM1
C     Error
           SUM = 0.
           DO   I=1,NREF
C        if(ih(i).eq.0.and.k(i).eq.0)goto 1032
             IHH = IH(I)
             IKK = K(I)
             CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
             FCALC(I) = FCALC(I) * SCALE
             ERR = ABS (WTS(I) - FCALC(I))
             SUM = SUM + ERR * ERR * MULTI(I)
             IF (ERR .GT. EBIG) THEN
               EBIG = ERR
             END IF
           END DO
           R = SQRT (SUM / SUM3)
C     Total R.M.S. Scatter
           IF (SCAT .GT. 1D-8) THEN
             SCAT = SQRT (SCAT / RR1)
           ELSE
             SCAT = 0.
           END IF
C     Largest scatter
           IF (PRINTF) THEN
             WRITE (6, 33) 'Iteration ', NITER, ' R.M.S: Err ', R,
     X          ' Scatter ', SCAT
             WRITE (10, 33) 'Iteration ', NITER, ' R.M.S: Err ', R,
     X          ' Scatter ', SCAT
C        write(10,34)'Largest scatter ',sbig,' for ',ih(isb),k(isb)
C        write(10,34)'Largest error   ',ebig,' for ',ih(isee),k(isee)
           END IF
 
   33      FORMAT(A,I3,A,E10.4,A,E10.4)
   34      FORMAT(A,F10.7,A,2I4)
           IF (R .GT. ROLD) GO TO 1000
           IF (ABS (R - ROLD) .LT. DD2) GO TO 1000
           ROLD = R
           IF (R .LT. TOL) GO TO 1000
           DO   I=1,NREF
             RR3 = FCALC(I)
             RR2 = WTS(I)
C           Update
C              if(ih(i).ne.0.or.k(i).ne.0)then
C           err=(wts(i)-fcalc(i))
             WW = (RR3 + REL1 * RR2) * REL2
C                write(10,901)ih(i),k(i),err,wts(i),fcalc(i),ww
             WTS(I) = WW
C               endif
  901        FORMAT(2I4,6F10.7)
           END DO
 
C       Rescale the 0,0
           WNORM = 1.D0 / WTS(I0)
           WTS(I0) = 1.
           DO   I=1,NREF
             IF (IH(I) .NE. 0 .OR. K(I) .NE. 0) THEN
               WTS(I) = WTS(I) * WNORM
               WTS(I) = MAX (0.0025D0, DBLE (WTS(I)))
             ELSE
               WTS(I) = 1.
             END IF
           END DO
         END DO
 
 1000    CONTINUE
C     Evaluate scaling term for peak max/total
C     This is used later in shpt2D.f
C     Do a negative FFT
         CALL FFT2DN (C)
 
C           Correction for the origin shift
C           Quench any imaginary component as a rounding error
         XMEAN = 0.
         XMAX = (-9999.)
         MF = (-1)
         JK = 0
         DO   I=1,N2
           MF = -MF
           NF = (-1)
           DO   J=1,N1
             JK = JK + 1
C
             NF = -NF
             X = C(JK) * (NF * MF)
             XMEAN = XMEAN + X
             IF (X .GT. XMAX) XMAX = X
           END DO
         END DO
         ACTERM = XMAX / XMEAN
C
         WNORM=WNORM*SCALE
C         WRITE (10, *) 'Final Self-Consistency Residual ', ROLD
C         WRITE (10, *) 'Window scaling ', WNORM,' Positivity ',POSRSCL
         TACC = ROLD
C       Setup MaxEnt Window
         call TACCENT (IH, K, NREF, SYMM, NHK, C, M ,ARAD)
         WRITE (10, *) 'Final Self-Consistency Residual ', ROLD
         WRITE (10, *) 'Window scaling ', WNORM,' Peak Width ',ARAD*2.0
 
C     remove fft tables
         CALL DPLN2D
         RETURN
       END
 
