       SUBROUTINE modelsharp0 (N1, N2, M, C, MPROJ )
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         REAL*8 XMEAN,XR,XI
        INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
C     Do a positivity cycle with model present
C     Do a FFT
         CALL FFT2DN (C)

C           Correction for the origin shift
C     Also find max, min and mean at the same time (of the model)
         XMEAN = 0.D0
         XMAX = (-99.)
         XMIN = 99.
         JK = 0
         MF = (-1)
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             XR = MAX( DBLE(C(JK)) * NF, 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK)) * NF), 0.D0)
             C(JK) = CMPLX (XR, XI)
             XMEAN = XMEAN + XR
C             WTMP1(JK)=XR
C             WTMP2(JK)=XI
           END DO
         END DO

C
C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'

C        Correct scaling, in parts where filter is active
         JK=0
         S1=0
         S2=0
         DO I=1,n1*n2
               JK=JK+1
               XR = C(JK)
               XI = AIMAG (C(JK))
C     Wiener-like filter for model
               S1 = S1 + XI*XR*FILT(JK)
               S2 = S2 + XI*XI*FILT(JK)
        ENDDO
        SCL = 1
         JK = 0
         MF = (-1)
         DO 2 I=1,N2
             MF = -MF
             NF = -MF
             DO 2 J=1,N1
               NF = -NF
               JK = JK + 1
               FAC = NF
               XR =  C(JK)
               XC = AIMAG (C(JK))*SCL
C     Otherwise, Wiener-filter type replacement
               XI = XC * FILT(JK) + (1 - FILT(JK)) * XR
               XI = MAX(XI, 0.D0)
               C(JK) = CMPLX(XI,XI) * FAC
    2    CONTINUE
         END IF

C     Invert
         CALL FFT2DP (C)
         RETURN
       END
