#ifndef __TMenubar_H__
#define __TMenubar_H__
#include "TMenu.h"

class TMenuBar {
	public:
		TMenuBar(TPane *pane,short width,short height=20) ;
		~TMenuBar() ;
		void	AddMenu(TMenu *menu) ;
		short	GetWidth() { return mWidth ; } ;
		short	GetHeight() { return mHeight ; } ;
		void 	Draw() ;
		void	HighlightMenuTitle(TMenu *menu,Boolean state) ;
		void 	DoMouseDown(Point *where) ;
	private:
    		long 	mHeight ;
    		long 	mWidth ;
    		uLong	mBkColor ;
    		uLong	mFgColor ;
    		long		mNumMenus ;
    		TMenu	*mMenus ;
    		TPane	*mWindowPane ;
} ;

#endif // __TMenubar_H__ 

