#ifndef __DFPDSPL__
#define __DFPDSPL__
#ifdef __MAIN__
struct {
          float cutoff ;   /* Sets the lowest intensity to be displayed */
          long   wavef  ;   /* True if we are looking at the wavefunction*/
          long   index  ;   /* True if we will index the diffraction pattern */
          float camera_length ; /* Camera length, starts with 520mm */
          float min_int ;       /* Minimum intensity to consider in the lens */
          long   xcenter ;   /* x-pos. of plotting center */
          long   ycenter ;   /* y-pos. of plotting center */
	  float theta ;	    /* Divergence angle to use for plotting D.P. */
} dfpdspl = {4.,0,0,520.,6.,383,255,0.5} ;
#else
extern struct {
          float cutoff ;   /* Sets the lowest intensity to be displayed */
          long   wavef  ;   /* True if we are looking at the wavefunction*/
          long   index  ;   /* True if we will index the diffraction pattern */
          float camera_length ; /* Camera length, starts with 520mm */
          float min_int ;       /* Minimum intensity to consider in the lens */
          long   xcenter ;   /* x-pos. of plotting center */
          long   ycenter ;   /* y-pos. of plotting center */
	  float theta ;	    /* Divergence angle to use for plotting D.P. */
} dfpdspl ;
#endif
#endif

