// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "menudef.h"
#include "header.h"
#include "menu_index.h"
#include "funcdefs.h"
extern  Boolean gNoGUI ;
void erase_message() {
  /* ----------------------------------------------- */
  /* Erases the message printed out by write_message */
  /* ----------------------------------------------- */
	
	if (gNoGUI) return ;
	
     extern MENUS gMenuList[] ;
     long xl,yl,xh,yh ;
  
     if (  gCurrentMenu==&gMenuList[MAIN_SNGL_STR] ||
           gCurrentMenu==&gMenuList[MAIN_LAY_STR]  ||
           gCurrentMenu==&gMenuList[CH_MAIN_PAR]) {
          xl = 0 ; 
          yl = 120 ; 
          xh = 1023 ; 
          yh = 152 ;
      }
      else if (gCurrentMenu==&gMenuList[DSPL_SOURCE]   ||           
               gCurrentMenu==&gMenuList[DSPL_OPER]     ||           
               gCurrentMenu==&gMenuList[SET_BR_CNTRST] ||           
               gCurrentMenu==&gMenuList[LAY_PG]        ||           
               gCurrentMenu==&gMenuList[SET_PG_SEQ]    ||           
               gCurrentMenu==&gMenuList[SEL_SNGL_LAY]  ||           
               gCurrentMenu==&gMenuList[REM_PG_LAY]    ||
               gCurrentMenu==&gMenuList[CRT_SWITCHES]  ||
               gCurrentMenu==&gMenuList[FB_SWITCHES]
              ) {
          xl = 0 ; 
          yl = 0 ; 
          xh = 850 ; 
          yh = 32 ;
          if (gCurrentMenu==&gMenuList[LAY_PG]       ||
              gCurrentMenu==&gMenuList[SET_PG_SEQ]   ||
              gCurrentMenu==&gMenuList[SEL_SNGL_LAY] ||
              gCurrentMenu==&gMenuList[REM_PG_LAY])
              xh = 830 ;
      }
      else {
          xl = 0 ; 
          yl = 60 ; 
          xh = 1023 ; 
          yh = 100 ;
      }
      eraser(xl,yl,xh,yh) ;
}
